#include <applicat.h>
#include <mask.h>
#include <relation.h>
#include <tabutil.h>
#include <progind.h>
#include <recarray.h>

#include "at4.h"
#include "at4700a.h"

// nomi dei campi
#include "soggetti.h"
#include "convoc.h"
#include "rconvoc.h"


class TEliminazioneConv: public TSkeleton_application
{
  TRelation*				_rel;
  TMask*      			_msk;
	TLocalisamfile* 	_rconvoc;
	TLocalisamfile* 	_soggetti;
	TDate							_dataini, _datafin;
  
protected:
  virtual bool create(void);
  virtual void main_loop();
  virtual bool destroy(void) ;

public:
  const TMask& msk() const { return *_msk; }
  
  TEliminazioneConv() {}
  virtual ~TEliminazioneConv() {}
};

// restituisce un riferimento all' applicazione
inline TEliminazioneConv& app() { return (TEliminazioneConv&) main_app();}

bool TEliminazioneConv::create()
{
  _msk = new TMask("at4700a");
  _rel = new TRelation(LF_RCONVOC);
  _rel->add(LF_SOGGETTI, "CODICE==CODICE");
  _rel->add(LF_CONVOC, "NUMERO==NUMERO");
  return TSkeleton_application::create();
}

// distruzione dell'applicazione
bool TEliminazioneConv::destroy()
{
  delete _rel;
  delete _msk;
  return TSkeleton_application::destroy();
}

// carica la maschera 
void TEliminazioneConv::main_loop()
{ 
  KEY key = K_ENTER;
  while (key != K_QUIT)
  {
    key = _msk->run();
    if (key == K_ENTER)
    {
    	TDate dataini = _msk->get_date(F_DATAINI);
    	TDate datafin = _msk->get_date(F_DATAFIN);
    }
  }
}

int at4700(int argc, char* argv[])
{
  TEliminazioneConv a ;
  a.run(argc, argv, "Eliminazione convocazioni su punto prelievo");
  return 0;
}

