#ifndef __BA1500_H__
#define __BA1500_H__

#ifndef __DONGLE_H
#include <dongle.h>
#endif

const int MAX_AUT = 48 * 3;

class TInformazione_moduli : public TObject
{
  TString_array _infos;
  int           _index[MAX_AUT];
  int           _unassigned_modules; // Moduli non assegnati, con descrizione vuota
  
public:
  const char* get_description_by_order(int index);
  const char* get_description_by_name(const char* name) const;

  const char* get_name_by_order(int index);
  int         get_module_by_order(int index);
  const char* get_description(int module);
  const char* get_name(int module);

  int         get_index(int module) const;
  int         get_index_by_name(const char* name) const;

  TDongleType get_owner(int module) const;
  bool        test_owner(int module, TDongleType owner) const;
  int         unassigned() const { return _unassigned_modules; }
  int         items() const { return _infos.items(); }
  TInformazione_moduli();
  virtual ~TInformazione_moduli() {};
};

bool update_dninst(bool force);
bool update_assistance_year();

#endif
