/* DEC	*AddLongToDecimal(pDst,pSrc1,l)
 *
 * ARGUMENT
 *	pDst is	a pointer to the destination DEC structure.
 *	pSrc1 is a ptr to the source1 DEC structure.
 *	l is the long to be added to pSrc1
 *
 * DESCRIPTION
 *	Adds the value 'l' to pSrc1 and	puts the result	in dest	DEC structure.
 *  The	sum is calculated to the maximum possible accuracy.
 *
 * SIDE	EFFECTS
 *	On overflow, the dest value is destroyed.
 *
 * RETURNS
 *	Returns	a pointer to the dest structure	unless overflow,
 *   when it returns a GM_NULL.	On error, the error
 *   is	in wGMError, unless an error was already there.
 *
 * POSSIBLE ERROR CODES
 *
 *	GM_NULLPOINTER
 *	GM_OVERFLOW
 *
 * AUTHOR
 *  Andy Anderson   08-JUL-1987	 1500
 *   Copyright (C) 1987-1990 Greenleaf Software	Inc.  All rights reserved.
 *
 * MODIFICATIONS
 *
 */

#include <stdio.h>
#include "gm.h"
#include "gmsystem.h"

DEC	*AddLongToDecimal(pDst,pSrc1,l)
DEC	*pDst,*pSrc1;
long	l;
{
	DEC	decS2, *pSrc2=&decS2, *pd;

	_MacStart(GM_ADDLD);

	/*  Convert the	long to	a DEC int */
	(void) ConvLongToDecimal(pSrc2,l);

	pd = AddDecimal(pDst,pSrc1,pSrc2);

	_MacRet(pd);
}
