/* DEC	*ChangeSignDecimal(pDst,pSrc1)
 *
 * ARGUMENT
 *	DEC*	pDst	ptr to the destination DEC structure.
 *	DEC*	pSrc1	ptr to the source1 DEC structure.
 *
 * DESCRIPTION
 *	Sets pDst=-(pSrc1).
 *
 * SIDE	EFFECTS
 *	None.
 *
 * RETURNS
 *	Returns	a pointer to the DEC structure unless overflow.
 *   GM_NULL if	an overflow occurs.
 *
 * POSSIBLE ERROR CODES:
 *
 *	GM_NULLPOINTER
 *	GM_NOMEMORY
 *
 * AUTHOR
 *  Andy Anderson   13-JAN-1987	 17:20
 *   Copyright (C) 1987-1990 Greenleaf Software	Inc.  All rights reserved.
 *
 * MODIFICATIONS
 *
 */

#include <stdio.h>
#include "gm.h"
#include "gmsystem.h"

DEC	*ChangeSignDecimal(pDst,pSrc)
DEC	*pDst,*pSrc;
{

	_MacStart(GM_DCHGS);

	_MacInVar(pSrc,GM_NULL);
	_MacOutVar(pDst,GM_NULL);

	_MacDCopy(pDst,pSrc);
	_MacDChgs(pDst);

	_MacRet(pDst);
}
