/* int	FilePrintDecimal(stream, fmt, arg,)
 *
 * ARGUMENT
 *	FILE	*stream;
 *	char	*fmt;
 *	(?)	arg;
 *
 * DESCRIPTION
 *	Prints out arguments, which may	include	DEC structures,	to a file,
 *   according to the format string fmt.  The function converts	the DEC's
 *   to	strings	and calls fprintf.
 *
 * SIDE	EFFECTS
 *	None.
 *
 * RETURNS
 *	The number of characters printed, the return from fprintf.
 *
 * POSSIBLE ERRORS
 *	GM_NULLPOINTER
 *	GM_NULLSTRING
 *	GM_INVALIDID
 *	GM_CNVRW
 *	GM_EOF
 *
 * AUTHOR
 *  Jared Levy
 *   Copyright (C) 1987-1990 Greenleaf Software	Inc.  All rights reserved.
 *
 * MODIFICATIONS
 *
 *
 */

#include <stdio.h>
#include "gm.h"
#include "gmsystem.h"

int FilePrintDecimal(FILE *stream, char	*fmt, ELLIPSES)
{
	char	**outval, buffer[256];
	int	i;

	_MacStart(GM_DFPRINTF);

	if (!fmt)  {
		_MacErr(GM_NULLPOINTER);
		_MacRet(0);
	}

	outval = &fmt;
/* print the output */
	dsprintf(buffer, fmt,
		outval[1], outval[2], outval[3], outval[4], outval[5],
		outval[6], outval[7], outval[8], outval[9], outval[10]
#ifndef	_LDATA
		,outval[11], outval[12], outval[13], outval[14], outval[15],
		 outval[16], outval[17], outval[18], outval[19], outval[20]
#endif
		);

	i = fprintf(stream, "%s", buffer);

	if (i==EOF)
		_MacErr(GM_EOF);

	_MacRet(i);
}
