/* void	FreeDecimal(pSrc1)
 *
 * ARGUMENT
 *	pSrc1 is a ptr to the source DEC structure.
 *
 * DESCRIPTION
 *	Returns	storage	to DOS via free().
 *
 * SIDE	EFFECTS
 *	Does NOT CHECK to see if spaces	was allocated via malloc().
 *  Therefore, DOS will	lock up	cause cold reboot if unallocated
 *  space is freed
 *
 * RETURNS
 *	None.
 *
 * POSSIBLE ERROR CODES
 *
 *	GM_NULLPOINTER
 *
 * AUTHOR
 *  Andy Anderson   17-JAN-1987	 14:35
 *   Copyright (C) 1987-1990 Greenleaf Software	Inc.  All rights reserved.
 *
 * MODIFICATIONS
 *
 */


#include <stdio.h>
#include <malloc.h>
#include "gm.h"
#include "gmsystem.h"

void	FreeDecimal(pSrc1)
DEC	*pSrc1;
{
	_MacStart(GM_DFREE);
/*  Can't free null pointers */
	if(!pSrc1)  {
		_MacErr(GM_NULLPOINTER);
		_MacRetV;
	}

/*  But	we'll free him a DEC if	possible */
#ifdef	LATTICE
	free((char *) pSrc1);
#else
	free((char *) pSrc1);
#endif

	_MacRetV;
}

