/* DEC	*IntegerPartDecimal(pDst,pSrc)
 *
 * ARGUMENT
 *	DEC*	pDst	ptr to the destination DEC structure.
 *	DEC*	pSrc	ptr to the source DEC structure.
 *
 * DESCRIPTION
 *	Sets pDst to the integer part of pSrc.
 *
 * SIDE	EFFECTS
 *	None.
 *
 * RETURNS
 *	Returns	a pointer to the DEC structure unless pSrc is null.
 *
 * POSSIBLE ERROR CODES
 *
 *	GM_NULLPOINTER
 *	GM_NOMEMORY
 *
 * AUTHOR
 *  Andy Anderson   13-JAN-1987	 17:20
 *   Copyright (C) 1987-1990 Greenleaf Software	Inc.  All rights reserved.
 *
 * MODIFICATIONS
 *
 */

#include <stdio.h>
#include "gm.h"
#include "gmsystem.h"

DEC	*IntegerPartDecimal(pDst,pSrc)
DEC	*pDst,*pSrc;
{

	_MacStart(GM_DINT);
	_MacInVarD(pSrc);
	_MacOutVarD(pDst);

	(void) _TruncateDec80Bit(pDst, pSrc, 0);

	_MacRet(pDst);
}
