/* DEC	*DivideDecimalByInt(pDst,pSrc1,lSrc2);
 *
 * ARGUMENT
 *	DEC	*pDst;
 *	DEC	*pSrc1;
 *	int	lSrc2;
 *
 * DESCRIPTION
 *	Divides	pSrc1 by ConvIntToDecimal(lSrc2) and puts the result in
 *  pDst. pSrc1	and lSrc2 remain unchanged. Note that
 *  we always call the _DivDec80Bit() routine to do the	actual divide,
 *  sign chking, etc.
 *
 * SIDE	EFFECTS
 *	None.
 *
 * RETURNS
 *	Returns	pointer	to pDst	if successful, otherwise a GM_NULL. The
 *   type error	(GM_OVERFLOW, GM_NOMEMORY, GM_DIV0) is in wGMError
 *   if	wGMError didn't	contain	a previous error on entry.
 *
 * POSSIBLE ERROR CODES
 *
 *	GM_NULLPOINTER
 *	GM_UNDERFLOW
 *	GM_DIV0
 *
 * AUTHOR
 *  Andy Anderson   5-Mar-87	17:45
 *   Copyright (C) 1987-1990 Greenleaf Software	Inc.  All rights reserved.
 *
 * MODIFICATIONS
 *
 */

#include <stdio.h>
#include "gm.h"
#include "gmsystem.h"

DEC*	DivideDecimalByInt(pDst,pSrc1,lSrc2)
DEC	*pDst,*pSrc1;
int	lSrc2;
{

	DEC	*t;

	_MacStart(GM_DIVID);

	t = DivideDecimalByLong(pDst,pSrc1,(long) lSrc2);
	_MacRet(t);
}
