/* DEC	*ZeroDecimal(pSrc1)
 *
 * ARGUMENT
 *	pSrc1 is a ptr to the source1 DEC structure.
 *
 * DESCRIPTION
 *	Zeroes the structure pSrc1.
 *
 * SIDE	EFFECTS
 *	If a NULL ptr is passed, creates zeroed	NULL DEC for caller.
 *
 * RETURNS
 *	Returns	a ptr to the zeroed structure if successful.
 *   Otherwise returns a GM_NULL.
 *
 * POSSIBLE ERROR CODES
 *	GM_NULLPOINTER
 *
 * AUTHOR
 *  Andy Anderson   13-JAN-1987	 16:20
 *   Copyright (C) 1987-1990 Greenleaf Software	Inc.  All rights reserved.
 *
 * MODIFICATIONS
 *
 */

#include <stdio.h>
#include "gm.h"
#include "gmsystem.h"

DEC	*ZeroDecimal(DEC * x)
{

	_MacStart(GM_DZERO);

	_MacOutVarD(x);

	/* Then	zero the structure */
	_MacDZero(x);

	_MacRet(x);
}
