/* int	ReturnErrFuncNumAndClear()
 *
 * ARGUMENT
 *
 *
 * DESCRIPTION
 *	Sets wGMFunErrNum to 0,	and returns it's previous value.
 *
 * SIDE	EFFECTS
 *	Does NOT clear the variable wGMError (global error number).
 *  See	ReturnMathErrAndClear()	for that discussion.  If you want to
 *  write your own functions, or do your own checking, remember	that
 *  wGMFunErrNum may contain an	error function number, but wGMError could
 *  have been cleared by some previous call to ReturnMathErrAndClear().
 *  Function ClearMathError() unconditionally clears both and can be found
 *  in "gm.h". BE SURE YOU ARE A SOURCE	CODE USER AND KNOW WHAT	YOU ARE
 *  DOING WITH THESE VARIABLES,	AND HOW	THEY ARE EFFECTED BY THE INTERNAL
 *  ROUTINES, BEFORE YOU WRITE YOUR OWN	ERROR HANDLER!
 *
 * RETURNS
 *	Returns	value of wGMFunErrNum.
 *
 * POSSIBLE ERROR CODES
 *
 *	None.
 *
 * AUTHOR
 *  Andy Anderson   19-FEB-1987	 15:30
 *   Copyright (C) 1987-1990 Greenleaf Software	Inc.  All rights reserved.
 *
 * MODIFICATIONS
 *
 */

#include <stdio.h>
#include "gm.h"
#include "gmsystem.h"

int	ReturnErrFuncNumAndClear()
{
	int	i;

	i=wGMFunErrNum;
	wGMFunErrNum = 0;
	_wGMUser=0;
	return(i);
}
