/* Greenleaf Financial MathLib
*  Greenleaf Software, Inc.
*  Long Names and Short Names equal so the user can
*  Use the One they want (or intermix)...
*  Copyright (c) 1984-1990 Greenleaf Software, Inc.  All Rights Reserved.
*       Function Call Equates that offer the user
*  a shorter name to use in calling the mathlib.  Note
*  that it is the longer names that are actually in the
*  .obj and .lib files.
*/

#define adate360        AddDaysToDate360
#define adate365        AddDaysToDate365
#define adatenly        AddDaysToDate365NoLeapYear
#define addarr          AddDecimalArrays
#define addarrd         AddDecimalToDecimalArray
#define adddfd          AddDoubleToDecimal
#define addid           AddIntToDecimal
#define addld           AddLongToDecimal
#define daddstr         AddAscii
#define adduid          AddUnsToDecimal
#define adduld          AddUnsLongToDecimal
#define advpmt          AdvancePayment
#define amort           Amortize
#define amorttbl        AmortizeTable
#define atod            ConvAsciiToDecimal
#define atodr           ConvAsciiToDecimalRound
#define comp            CompoundInterest
#define compcomp        CompoundInterestCompound
#define compsimp        CompoundInterestSimple
#define dabs            AbsoluteDecimal
#define dacos           ArcCosineDecimal
#define dadd            AddDecimal
#define dalloc          AllocateDecimal
#define dalog           AntiLog10Decimal
#define daralloc        AllocateDecimalArray
#define darcpy          CopyDecimalArray
#define darfree         FreeDecimalArray
#define dasin           ArcSineDecimal
#define datan           ArcTangentDecimal
#define dbd360          DaysBetweenDates360
#define dbd365          DaysBetweenDates365
#define dbdnly          DaysBetweenDates365NoLeapYear
#define dchgs           ChangeSignDecimal
#define dcmp            CompareDecimal
#define dcos            CosineDecimal
#define dcot            CotangentDecimal
#define dcpy            CopyDecimal
#define dctod           ConvDollarsAndCentsToDecimal
#define ddeg            ConvRadiansToDegrees
#define ddiv            DivideDecimal
#define ddivr           DivideDecimalAndRound
#define ddivt           DivideDecimalAndTruncate
#define deltrz          DeleteTrailingZeroes
#define dexp            AntiLogEDecimal
#define dfact           Factorial
#define dfprintf        FilePrintDecimal
#define dfract          FractionDecimal
#define dfree           FreeDecimal
#define dfscanf         FileScanDecimal
#define dftod           ConvDoubleToDecimal
#define dftodr          ConvDoubleToDecimalRound
#define dint            IntegerPartDecimal
#define diseq           IsDecimalEqual
#define disge           IsDecimalGreaterOrEqual
#define disgt           IsDecimalGreater
#define disint          IsDecimalInt
#define disle           IsDecimalLessOrEqual
#define dislt           IsDecimalLess
#define disne           IsDecimalNotEqual
#define disneg          IsDecimalNegative
#define dispos          IsDecimalPositive
#define diszero         IsDecimalZero
#define divarr          DivideDecimalArrays
#define divarrd         DivideDecimalArrayByDecimal
#define divdfd          DivideDecimalByDouble
#define divid           DivideDecimalByInt
#define divld           DivideDecimalByLong
#define divstr          DivideAscii
#define divuid          DivideDecimalByUns
#define divuld          DivideDecimalByUnsLong
#define dln             LogEDecimal
#define dlog            Log10Decimal
#define dmag            MagnitudeOfDecimal
#define dmant           DecimalMantissa
#define dmax            MaximumDecimal
#define dmean           StatMean
#define dmin            MinimumDecimal
#define dmod            ModuloDecimal
#define dmoddf          DecimalModuloDouble
#define dmodi           DecimalModuloInt
#define dmodl           DecimalModuloLong
#define dmodui          DecimalModuloUns
#define dmodul          DecimalModuloUnsLong
#define dmul            MultiplyDecimal
#define dmulr           MultiplyDecimalAndRound
#define dmult           MultiplyDecimalAndTruncate
#define dpct            DecimalPercentage
#define dpdb            DepreciateDeclining
#define dpdbtbl         DepreciateDecliningTable
#define dpddb           DepreciateDoubleDeclining
#define dpddbtbl        DepreciateDoubleDecliningTable
#define dpow            PowerDecimal
#define dpowi           PowerInteger
#define dpowrat         PowerRational
#define dprec           DecimalPrecision
#define dprintf         PrintDecimal
#define dpsl            DepreciateStraightLine
#define dpsltbl         DepreciateStraightLineTable
#define dpsoy           DepreciateSumOfYears
#define dpsoytbl        DepreciateSumOfYearsTable
#define drad            ConvDegreesToRadians
#define droot           RootDecimal
#define drooti          RootInteger
#define dround          RoundDecimal
#define dscanf          ScanDecimal
#define dsetertn        SetMathErrVector
#define dsign           TestSignDecimal
#define dsin            SineDecimal
#define dsprintf        StringPrintDecimal
#define dsqrt           SquareRootDecimal
#define dsscanf         StringScanDecimal
#define dsub            SubtractDecimal
#define dtan            TangentDecimal
#define dtoa            ConvDecimalToAscii
#define dtoac           ConvDecimalToAsciiComma
#define dtoacr          ConvDecimalToAsciiCommaRound
#define dtoar           ConvDecimalToAsciiRound
#define dtodc           ConvDecimalToDollarsAndCents
#define dtodf           ConvDecimalToDouble
#define dtoeng          ConvDecimalToEngineering
#define dtofr           ConvDecimalToFraction
#define dtoi            ConvDecimalToInt
#define dtol            ConvDecimalToLong
#define dtosci          ConvDecimalToScientific
#define dtoui           ConvDecimalToUns
#define dtoul           ConvDecimalToUnsLong
#define dtrunc          TruncateDecimal
#define dzero           ZeroDecimal
#define dzeroarr        ZeroDecimalArray
#define efftonom        ConvEffectiveToNominal
#define errname         ErrorName
#define frtod           ConvFractionToDecimal
#define funname         FunctionName
#define gmec            ReturnMathErrAndClear
#define gmef            ReturnErrFuncNumAndClear
#define gmrs            ClearMathError
#define irr             InternalRateOfReturn
#define itod            ConvIntToDecimal
#define linest          LinearEstimate
#define lookarr         LookUpDecimalArray
#define ltod            ConvLongToDecimal
#define makid           MakeDecimalFromInt
#define makld           MakeDecimalFromLong
#define makuid          MakeDecimalFromUns
#define makuld          MakeDecimalFromUnsLong
#define maxarr          FindMaximumDecimalArray
#define minarr          FindMinimumDecimalArray
#define mirr            ModifiedIRR
#define mularr          MultiplyDecimalArrays
#define mularrd         MultiplyDecimalArrayByDecimal
#define muldfd          MultiplyDecimalByDouble
#define mulid           MultiplyDecimalByInt
#define mulld           MultiplyDecimalByLong
#define mulstr          MultiplyAscii
#define muluid          MultiplyDecimalByUns
#define mululd          MultiplyDecimalByUnsLong
#define nfv             NetFutureValue
#define nomtoeff        ConvNominalToEffective
#define npv             NetPresentValue
#define padd            AddPercent
#define pchange         PercentChange
#define pdiv            DividePercent
#define pmul            MultiplyPercent
#define pof             PercentOf
#define predx           PredictX
#define predy           PredictY
#define psub            SubtractPercent
#define ptoy            ConvPeriodicToYearly
#define roundcnt        RoundCents
#define simp360         SimpleInterest360
#define simp365         SimpleInterest365
#define spfv            SinglePaymentFutureValue
#define sppv            SinglePaymentPresentValue
#define stnddev         StandardDeviation
#define subarr          SubtractDecimalArrays
#define subarrd         SubtractDecimalFromDecimalArray
#define subdfd          SubtractDoubleFromDecimal
#define subid           SubtractIntFromDecimal
#define subld           SubtractLongFromDecimal
#define substr          SubtractAscii
#define subuid          SubtractUnsFromDecimal
#define subuld          SubtractUnsLongFromDecimal
#define sumarr          SumDecimalArray
#define sumarrn         SumDecimalArrayNegative
#define sumarrp         SumDecimalArrayPositive
#define trunccnt        TruncateCents
#define uitod           ConvUnsToDecimal
#define ultod           ConvUnsLongToDecimal
#define usfv            UniformSeriesFutureValue
#define uspv            UniformSeriesPresentValue
#define wmean           WeightedMean
#define ytop            ConvYearlyToPeriodic
