/* DEC	*MultiplyDecimalByUns(pDst,pSrc1,pSrc2);
 *
 * ARGUMENT
 *	DEC	*pDst;
 *	DEC	*pSrc1;
 *	unsigned pSrc2;
 *
 * DESCRIPTION
 *	Multiplies pSrc1 times ConvIntToDecimal(pSrc2) & puts it Into pDst.
 *  pSrc1 and pSrc2 remain unchanged. Note that	we always call the
 *  _MulDec80Bit() routine to do the actual multiply, sign chking, etc.
 *
 * SIDE	EFFECTS
 *	*pDst is indeterminate on error.
 *
 * RETURNS
 *	Returns	poInter	to pDst	if successful, otherwise a GM_NULL. The
 *   type error	(GMOVERFLOW, GMUNDERFLOW, GMNOMEMORY) is in wGMError
 *   if	wGMError didn't	contain	a previous error on entry.
 *
 * POSSIBLE ERROR CODES
 *
 *	GM_NULLPOINTER
 *	GM_OVERFLOW
 *
 * AUTHOR
 *  Andy Anderson   5-Mar-87	17:15
 *   Copyright (C) 1987-1990 Greenleaf Software	Inc.  All rights reserved.
 *
 * MODIFICATIONS
 *
 */

#include <stdio.h>
#include "gm.h"
#include "gmsystem.h"

DEC*	MultiplyDecimalByUns(pDst,pSrc1,pSrc2)
DEC	*pDst,*pSrc1;
unsigned int pSrc2;
{
	DEC	*t;

	_MacStart(GM_MULUID);

	t = MultiplyDecimalByLong(pDst,pSrc1,(long) pSrc2);
	_MacRet(t);
}
