/* DEC	*ConvUnsLongToDecimal( x, l)
 *
 * ARGUMENT
 *	DEC	*x;
 *	unsigned long	l;
 *
 * DESCRIPTION
 *	Converts unsigned long 'l' to a	DEC with implied decimal 0.
 *
 * SIDE	EFFECTS
 *	*x is indeterminate on error.
 *
 * RETURNS
 *	The DEC	if the conversion is successful, and GM_NULL otherwise.
 *
 * POSSIBLE ERROR CODES
 *
 *	GM_NULLPOINTER
 *
 * AUTHOR
 *   Jared Levy		Feb. 9,	1987
 *   Copyright (C) 1987-1990 Greenleaf Software	Inc.  All rights reserved.
 *
 * MODIFICATIONS
 *
 */

#include <stdio.h>
#include "gm.h"
#include "gmsystem.h"

DEC	*ConvUnsLongToDecimal( x, l)
DEC	*x;
unsigned long	l;

{
	/* handle null destinations */
	_MacStart(GM_ULTOD);

	_MacOutVarD(x);

	x->ls.lmsd = 0;
	x->ls.lsl[1] = 0L;
	x->ls.lsl[0] = l;
	x->ls.lid = 0;
	x->ls.lattr= 0;

	_MacRet(x);
}
