#ifndef __COLORS_H
#define __COLORS_H

#ifndef __STDTYPES_H
#include <stdtypes.h>
#endif   

#ifndef XVT_INCL_XVT
#include <xvt.h>
#endif   

COLOR RGB2COLOR(unsigned char red, unsigned char green, unsigned char blue);
COLOR choose_color(COLOR col = COLOR_BLACK, WINDOW win = NULL_WIN);
COLOR blend_colors(COLOR col1, COLOR col2, double perc = 0.5);
unsigned int color_distance(COLOR col1, COLOR col2);

extern COLOR MASK_BACK_COLOR;
extern COLOR MASK_LIGHT_COLOR;
extern COLOR MASK_DARK_COLOR;
extern COLOR BTN_BACK_COLOR;
extern COLOR BTN_LIGHT_COLOR;
extern COLOR BTN_DARK_COLOR;
extern COLOR TOOL_BACK_COLOR;
extern COLOR NORMAL_COLOR;
extern COLOR NORMAL_BACK_COLOR;
extern COLOR DISABLED_COLOR;
extern COLOR DISABLED_BACK_COLOR;
extern COLOR FOCUS_COLOR;
extern COLOR FOCUS_BACK_COLOR;
extern COLOR REQUIRED_BACK_COLOR;

extern bool CAMPI_SCAVATI; 
extern bool ADVANCED_GRAPHICS; 
extern bool AUTOSELECT;
extern bool SMALL_ICONS;

const COLOR COLOR_DKCYAN = MAKE_COLOR(0,128,128);
const COLOR COLOR_DKYELLOW = MAKE_COLOR(128,128, 0);
const COLOR COLOR_DKGREEN = MAKE_COLOR(0,128, 0);
const COLOR COLOR_DKBLUE = MAKE_COLOR(0,0,128);
const COLOR COLOR_DKRED = MAKE_COLOR(128,0, 0);
const COLOR COLOR_DKMAGENTA = MAKE_COLOR(128,0,128);

#endif
