#ifndef __ISAMRPC_H
#define __ISAMRPC_H                                  

#ifndef __ARRAY_H
#include <array.h>
#endif   

#ifndef __REAL_H
#include <real.h>
#endif   

bool  rpc_Call(const char* cmd);
char* rpc_Request(const char* cmd, unsigned long& size, real& time);

bool        rpc_DongleHasModule(word af);
bool        rpc_DongleModules(TBit_array& ba);
unsigned    rpc_DongleNumber();
unsigned    rpc_DongleYear();

bool        rpc_UserLogin(const char* server, const char* user, 
                          const char* password, const char* application);
bool        rpc_UserLogout();  

bool        rpc_Start();
bool        rpc_Stop();

bool        http_get(const char* server, const char* remote_file, 
                     const char* local_file, const char* authorization = NULL);
bool        http_dir(const char* server, const char* remote_dir, TString_array & list);
bool        http_post(const char* server, const char* remote_file, 
                      const char* local_file, const char* authorization, 
                      byte*& answer, size_t& length);


#endif