#define FF_DATAMOV 555

USE LF_RMOVMAG BY NUMREG NRIG
JOIN LF_MOVMAG TO LF_RMOVMAG INTO NUMREG==NUMREG
JOIN %CAU TO 110 INTO CODTAB==CODCAUS
JOIN LF_ANAMAG TO LF_RMOVMAG INTO CODART==CODART 
JOIN LF_DOC TO LF_MOVMAG INTO PROVV==DOCPROVV ANNO==ANNODOC CODNUM==CODNUM NDOC==NUMDOC
JOIN %CAU TO 111 ALIAS 500 INTO CODTAB==CAUS

JOIN LF_UMART TO LF_RMOVMAG KEY 2 ALIAS 349 INTO CODART==CODART UM==UM
JOIN LF_UMART TO LF_ANAMAG  ALIAS 249 INTO CODART==CODART 
JOIN LF_CLIFO TO LF_MOVMAG INTO TIPOCF==TIPOCF CODCF==CODCF
END
  
DESCRIPTION
BEGIN
    LF_ANAMAG->* "Anagrafica articoli"
    LF_MOVMAG->* "Movimenti di magazzino"
    LF_RMOVMAG->* "Righe Movimenti di magazzino"
    49->* "Unit di misura articoli"
    33->* "documenti"
    LF_CLIFO->* "Clienti/Fornitori"
END

GENERAL
BEGIN
    OFFSET 0 1
//    FONT "Courier New"
//    SIZE 10
END


SECTION GRAPHIC
BEGIN
END

SECTION HEADER ODD 5

STRINGA 1 40 1
BEGIN
 KEY "nome ditta"
 PROMPT  1 1 "Ditta "
 MESSAGE _DITTA, !RAGSOC
END

STRINGA 2 10
BEGIN
 KEY "Data"
 PROMPT  104 1 "Data "
 MESSAGE _TODAY
END

NUMERO 3 7
BEGIN
 KEY "Nr. pagina"
 PROMPT  121 1 "Pagina "
 MESSAGE _PAGENO
END

NUMERO 4 25
BEGIN
 KEY "Intestazione stampa"
 PROMPT  45 2 "Stampa lista movimenti"
END

STRINGA 5 132
BEGIN
  KEY "Separatore (iniziale)"
  PROMPT 1 3 "------------------------------------------------------------------------------------------------------------------------------------------------------"
END

STRINGA 101 
BEGIN
  KEY ""
  PROMPT  2 4 "Cod.mag."
END

STRINGA 103 20
BEGIN
  KEY ""
  PROMPT  13 4 "Articolo"
END

STRINGA 104 40
BEGIN
  KEY ""
  PROMPT  35 4 "Descrizione articolo"
END


STRINGA 105 
BEGIN
  KEY "UMART"
  PROMPT  82 4 "UM"
END

NUMERO 106
BEGIN
  KEY "quant"
  PROMPT  86 4 "Quantita'"
END

VALUTA 107
BEGIN
  KEY "prezzo"
  PROMPT  104 4 "Prezzo"
  FLAGS "U"
END

VALUTA 108
BEGIN
  KEY "valore"
  PROMPT  122 4 "Valore"
END

STRINGA 100 132
BEGIN
  KEY "Separatore (iniziale)"
  PROMPT 1 5 "------------------------------------------------------------------------------------------------------------------------------------------------------"
END


END

SECTION BODY ODD 1
  NUMERO 1 15
  BEGIN
    FLAGS "H"
    KEY "ENabler"
    MESSAGE SHOW,FF_DATAMOV
  END

  SECTION HEADER_DATA 1 6 1 GROUP 
    DATA 1 
    BEGIN
      KEY "raggr fdata"
      PROMPT  1 1 "------------- Registrazioni del "
      FIELD LF_MOVMAG->DATACOMP
      MESSAGE HIDE,FF_DATAMOV
    END
  END
 
  SECTION RAGG_MOV 1 4 4 FILE LF_RMOVMAG GROUP LF_MOVMAG->DATACOMP

    NUMERO 1 15
    BEGIN
      KEY "numreg"
      PROMPT  1 1 "Num.Reg. "
      FIELD LF_MOVMAG->NUMREG
      PICTURE "#####"
      MESSAGE RESET,15
    END

    DATA FF_DATAMOV 10
    BEGIN
      KEY "datacomp"
      PROMPT  16 1 "del "
      FIELD LF_MOVMAG->DATACOMP
    END
    STRINGA 3 40
      BEGIN
      KEY "descr mov"
      PROMPT  35 1 ""
      FIELD LF_MOVMAG->DESCR
    END
    STRINGA 4 24
      BEGIN
      KEY " CAUS mov"
      PROMPT  4 2 "Causale movimento "
      FIELD LF_MOVMAG->CODCAUS
    END
    STRINGA 5 50
    BEGIN
      KEY " DESCR CAUS"
      PROMPT  35 2 ""
      FIELD %CAU->S0
    END
    LIST 10 11
    BEGIN 
      KEY "Cliente/Fornitore"
      PROMPT 4 3 ""
      FIELD LF_CLIFO->TIPOCF
      ITEM " | "
      ITEM "C|Cliente"
      ITEM "F|Fornitore"
    END                
              
    NUMERO 11 6
    BEGIN
      KEY "Codice"
      PROMPT 14 3 ""
      FIELD LF_CLIFO->CODCF  
      PICTURE "######"
    END
    
    STRINGA 12 50
    BEGIN
      KEY "Ragione Sociale"
      PROMPT 22 3 ""
      FIELD LF_CLIFO->RAGSOC
    END            


    SECTION INFO_EXDOC 4 1 1 NUM_EXPR LF_MOVMAG->EX_NUMDOC!=0
      STRINGA 6 20
      BEGIN
        KEY " NUMDOC"
        PROMPT  10 1 "Documento "
        FIELD LF_MOVMAG->EX_NUMDOC
      END
      STRINGA 7 20
      BEGIN
        KEY " datadoc"
        PROMPT  30 1 "del "
        FIELD LF_MOVMAG->EX_DATADOC
      END
    END


    SECTION RIGHE_MOV 4 2 1 FILE LF_RMOVMAG GROUP NUMREG
      SECTION CAUS_RIGA 1 1 1 STREXPR LF_RMOVMAG->CAUS!=""
        STRINGA 4 24
          BEGIN
          KEY " CAUS mov"
          PROMPT  10 1 "Causale riga      "
          FIELD LF_RMOVMAG->CAUS
        END
        STRINGA 5 50
        BEGIN
          KEY " DESCR CAUS"
          PROMPT  34 1 ""
          FIELD 500@->S0
        END
      END

      STRINGA 101 3
      BEGIN
        KEY ""
        PROMPT  4 1 ""
        FIELD LF_RMOVMAG->CODMAG[1,3]
      END
      STRINGA 102 3
      BEGIN
        KEY ""
        PROMPT  8 1 ""
        FIELD LF_RMOVMAG->CODMAG[4,5]
      END

      STRINGA 103 20
      BEGIN
        KEY ""
        PROMPT  13 1 ""
        FIELD LF_RMOVMAG->CODART
      END

      STRINGA 104 40
      BEGIN
        KEY ""
        PROMPT  35 1 ""
        FIELD LF_ANAMAG->DESCR
      END

      //STRINGA 105 4
      //BEGIN
      //  KEY "CAUS"
      //  PROMPT  77 1 ""
      //  FIELD LF_RMOVMAG->CAUS
      //END

      STRINGA 105 20
      BEGIN
        KEY "UMART"
        PROMPT  82 1 ""
        FIELD LF_RMOVMAG->UM
      END

      NUMERO 106
      BEGIN
        KEY "quant"
        PROMPT  85 1 ""
        FIELD LF_RMOVMAG->QUANT
        PICTURE "####.###,@##"
      END

      VALUTA 107 13
      BEGIN
        KEY "prezzo"
        PROMPT  99 1 ""
        FLAGS "U"
        FIELD LF_RMOVMAG->PREZZO
        PICTURE "#.###.###.##@"
      END

      VALUTA 108 14
      BEGIN
        KEY "valore"
        PROMPT  114 1 ""
        MESSAGE _NUMEXPR,LF_RMOVMAG->PREZZO*LF_RMOVMAG->QUANT*349@->FC|ADD,15
        PICTURE "##.###.###.##@"
      END

    END // RIGHE MOVIMENTO

    STRINGA 14
    BEGIN
      KEY "totale mov"
      PROMPT  85 4 "Valore movimento: "
    END             
    
    VALUTA 15 17
    BEGIN
      KEY "totale mov"
      PROMPT  111 4 ""
      MESSAGE ADD,FL->215
      PICTURE "#.###.###.###.##@"
    END
 END

END // BODY SECTION

SECTION FOOTER ODD 3
END                 

SECTION FOOTER LAST 3
    STRINGA 214
    BEGIN
      KEY "totale mov"
      PROMPT  85 1 "Totale valore  : "
    END
    VALUTA 215 17
    BEGIN
      KEY "totale mov"
      PROMPT  111 1 ""
      PICTURE "#.###.###.###.##@"
    END
END

