#ifndef __MG4200A_H
#define __MG4200A_H

#define MAX_VAL_COLUMNS 6

class TForm_inventario : public TForm_stampemg
{
  int _colonne;
  TSorted_cursor *_sortcur; // Cursore sortato: RAGGFIS+CODART usato in stampe per raggr. fisc.
  TConfig *conf_ditta;
  bool _use_alternate_cursor;
  TArticolo_giacenza_loadable * _curr_art;
  TString16 _codlist,_catven; // codici listino e cat vendita
  bool _giaceff,   // flag inventario di giacenza
       _valcomp,   // flag valorizzzione finiti o componenti
       _alladata,  // flag di stampa inventario alla data, per utilizzare TArticolo_giacenza_loadable
       _pos,       // flag di stampa inventario positivi
       _notzero;   // flag di stampa inventario non zero
  int  _annoes;
	TTipo_valorizz _valorizz_scelte[MAX_VAL_COLUMNS]; // valorizzazioni delle varie colonne

  TCurrency      *_currency;
  TArticolo_giacenza_loadable &curr_art();
public:
  virtual TCursor* cursor() const ;
  
  bool genera_intestazione_supplementare(pagetype p, short y);
  void set_parametri(const char * codcm,const char * cod,bool giaceff, bool valcomp, bool alladata, int annoes);
  bool valorizzazione(TForm_item &cf, TTipo_valorizz t);
  bool validate(TForm_item &cf, TToken_string &s);
  void use_alternate_cursor(const bool b = TRUE) { _use_alternate_cursor = b; }
  void add_colval(int tipo);
  TForm_inventario(const char *name,const char *code) ;
  ~TForm_inventario();
};

class TStampa_inventario : public TSkeleton_application
{
  TArray * _files;
  TStampemg_mask * _mask;
  TCursor * _cur;
  TForm_inventario * _form; // to be moved into TPrint_application

protected:
  virtual bool create();
  virtual bool destroy();
  virtual void main_loop();
  virtual void on_firm_change();

  void setprint_permagazzini();
  void setprint_perarticoli();
  void setprint_perarticoli_all();
  bool crea_tempmag(const bool b = TRUE);
  bool calcola_giacenze(const bool b = TRUE);
  virtual void set_def_valuta(TForm_inventario & f) {}

public:
  TStampa_inventario() {}
};                

#endif //__MG4200A_H
