#ifndef __CONNECT_H__
#define __CONNECT_H__

#ifndef __NETUTILS_H__
#include "NetUtils.h"
#endif

/////////////////////////////////////////////////////////////////////////////
// PrassiConnection

class TPrassiConnection : public TConnection
{
	CString m_strUser;
	CString m_strApp;
  CString m_strPeer;
	int     m_nFirm;
	
protected:
	BOOL Trace(int level, const char* str) const;

public:
	virtual BOOL Request(const char* cmd);
	virtual BOOL Execute(const char* cmd) { return Request(cmd); }

public:
	
	BOOL DoUserLogin(const CString& user, const CString& pwd, const CString& app);
	BOOL DoUserLogout();
	
public:

	int GetFirm() const { return m_nFirm; }
	BOOL SetFirm(int nFirm);

	const CString& User() const { return m_strUser; }
	const CString& Application() const { return m_strApp; }
  const CString& PeerName() const { return m_strPeer; }

  TPrassiConnection(TLanManager* lm, DWORD id, const char* name);
	virtual ~TPrassiConnection();
};

int f_DongleHasModule(TConnection& conn, void* pJolly);
int f_DongleModules  (TConnection& conn, void* pJolly);
int f_DongleNumber   (TConnection& conn, void* pJolly);
int f_DongleYear     (TConnection& conn, void* pJolly);

int f_UserLogin      (TConnection& conn, void* pJolly);
int f_UserLogout     (TConnection& conn, void* pJolly);

#endif
