#ifndef __CONNECT_H__
#define __CONNECT_H__

#ifndef __NETUTILS_H__
#include "NetUtils.h"
#endif

#ifndef __SQLFILE_H__
#include "sqlfile.h"
#endif

/////////////////////////////////////////////////////////////////////////////
// PrassiConnection

class TPrassiConnection : public TConnection
{
	CString m_strUser;
	CString m_strApp;
	int     m_nFirm;
	
	CMap<long, long, TSqlFile*, TSqlFile*> m_sqlFiles;

protected:
	BOOL Trace(int level, const char* str) const;

public:
	virtual BOOL Request(const char* cmd);
	virtual BOOL Execute(const char* cmd) { return Request(cmd); }

	long      OpenFile(int nLogicNum, LPCSTR sWhere);
	TSqlFile* GetFile(long nHandle);
    BOOL      CloseFile(long nHandle);

public:
	
	BOOL DoUserLogin(const CString& user, const CString& pwd, const CString& app);
	BOOL DoUserLogout();
	
public:

	int GetFirm() const { return m_nFirm; }
	BOOL SetFirm(int nFirm);

	const CString& User() const { return m_strUser; }

    TPrassiConnection(TLanManager* lm, DWORD id);
	virtual ~TPrassiConnection();
};

int f_DongleHasModule   (TConnection& conn, void* pJolly);
int f_DongleModules     (TConnection& conn, void* pJolly);
int f_DongleNumber      (TConnection& conn, void* pJolly);

int f_FileClearFields	(TConnection& conn, void* pJolly);
int f_FileClose			(TConnection& conn, void* pJolly);
int f_FileFirst			(TConnection& conn, void* pJolly);
int f_FileGetField		(TConnection& conn, void* pJolly);
int f_FileGetFieldInfo	(TConnection& conn, void* pJolly);
int f_FileGetItems		(TConnection& conn, void* pJolly);
int f_FileGetKey		(TConnection& conn, void* pJolly);
int f_FileGetKeyExpr	(TConnection& conn, void* pJolly);
int f_FileGetPosition	(TConnection& conn, void* pJolly);
int f_FileLast			(TConnection& conn, void* pJolly);
int f_FileLock			(TConnection& conn, void* pJolly);
int f_FileMove			(TConnection& conn, void* pJolly);
int f_FileNext			(TConnection& conn, void* pJolly);
int f_FileOpen			(TConnection& conn, void* pJolly);
int f_FileOpenTable		(TConnection& conn, void* pJolly);
int f_FilePrev			(TConnection& conn, void* pJolly);
int f_FileRead			(TConnection& conn, void* pJolly);
int f_FileRemove		(TConnection& conn, void* pJolly);
int f_FileRewrite		(TConnection& conn, void* pJolly);
int f_FileSetField		(TConnection& conn, void* pJolly);
int f_FileSetKey		(TConnection& conn, void* pJolly);
int f_FileSkip			(TConnection& conn, void* pJolly);
int f_FileUnlock		(TConnection& conn, void* pJolly);
int f_FileWrite			(TConnection& conn, void* pJolly);

int f_FirmGet			(TConnection& conn, void* pJolly);
int f_FirmSet			(TConnection& conn, void* pJolly);
int f_FirmTest			(TConnection& conn, void* pJolly);

int f_FtpGetFile		(TConnection& conn, void* pJolly);

int f_UserLogin			(TConnection& conn, void* pJolly);
int f_UserLogout		(TConnection& conn, void* pJolly);

#endif
