#define __STDTYPES_CPP

#include <stdtypes.h>
#include <extcdecl.h>

#include <isam.h>
#include <prefix.h>
#include <utility.h>
#include <codeb.h>

short CHARY,CHARX;

void init_global_vars()
{
  prefix_init();
  CGetPref();
  prefix().set("");

  FileDes d;
  CGetFile(LF_DIR, &d, _nolock, NORDIR);
  long maxfdir = d.EOX;
  prefix().set("DEF");

  CGetFile(LF_DIR, &d, _nolock, NORDIR);
  if (d.EOD > maxfdir) maxfdir = d.EOD;

  openf = new isfdptr[maxfdir];
  openrec = new TRectype*[maxfdir];

  for (long i = 0; i < maxfdir; i++)
  {
    openf[i] = NULL;
    openrec[i] = NULL;
  }
  DB_init();
}

void free_global_vars()
{
  delete openrec;
  delete openf;
  prefix_destroy();
  DB_exit();
}


#include <pro_ext.h>

void* operator new(size_t size)
{            
  MHANDLE hnd = _AllocHand(size+2);
  if (hnd == 0) fatal_box("Out of memory handles");
  _HLock(hnd);
  MHANDLE * phnd = (MHANDLE *) _HandToPtr(hnd);
  *phnd = hnd;
  return (void*) (phnd+1);
}  

void operator delete(void* ptr)
{ 
  if (ptr == NULL) fatal_box("Can't delete NULL handle");
  MHANDLE * phnd = ((MHANDLE *) ptr) - 1;
  _HUnLock(*phnd);
  _FreeHand(*phnd);
}

static bool get_fox(const char* var, char* val)
{
  *val = '\0';

  const NTI nti = _NameTableIndex((char*)var);
  if (nti >= 0)
  {
    Locator loc;
    if (_FindVar(nti, -1, &loc)) // Find memory variable
    {
      Value value;
      _Load(&loc, &value);
      if (value.ev_type == 'C') 
      {
        const char* p = (const char*)_HandToPtr(value.ev_handle);
        if (*p > ' ') 
          strcpy(val, p);
      }   
    }
  }

  return *val != '\0';
}

static char _tmp[256];

char* prefname()
{ 
  if (!get_fox("PREFPATH", _tmp))
    strcpy(_tmp, "prefix.txt");
  
  return _tmp;  
}

const char* username()
{
  if (!get_fox("USER", _tmp))
    strcpy(_tmp, "PRASSI");
  return _tmp;  
}

const char* tempdir()
{
  char user[16];
  strncpy(user, username(), 16);

  if (!get_fox("TEMPDIR", _tmp))
    strcpy(_tmp, "\\tmp");
  if (!fexist(_tmp)) 
    make_dir(_tmp);
  
  strcat(_tmp, "\\"); strcat(_tmp, user);
  if (!fexist(_tmp)) 
    make_dir(_tmp);
  
  return _tmp;  
}


