#include <windows.h>
#include <time.h>

/*
Funzione HL_GETAUT
prende in input il numero del modulo
di cui si vuole sapere l'abilitazione
restituisce:
0 se non abilitato
1 se abilitato
*/
int hl_getaut(int modulo)
{
  char risultato[18];
  char tmp_res[18]
  char stringa_segreta[18]
  char casuale[36]
  char chiave[18]
  int abilitazione = 0,i;

  strcpy(stringa_segreta,"P39S41");
  /* Generare un numero casuale di 6 cifre... */
  srand( (unsigned)time( NULL ) );
  sprintf(casuale,"%d%d%d%d%d%d", rand(),rand(),rand(),rand(),rand(),rand() );
  casuale[6] = '\0'; /* Tronca a 6 la stringa casuale */
  /* Gli ultimi 3 caratteri della stringa sara' il modulo zerofilled (ex: 21 -> 021, 7 -> 007 ecc */
  sprintf(casuale,"%s%03d",casuale,modulo);
  /* Compone la chiave: stringa_segreta + i primi 3 caratteri della stringa casuale */
  strcpy(chiave,stringa_segreta);
  strcat(chiave,casuale);
  chiave[9] = '\0';

  /* Codifica la stringa chiave tramite la stringa casuale */
  /* Esegue la somma algebrica dei valori ASCII dei singoli caratteri */
  for (i=0; i < 16; i++)
  {
    if (i>8)
      risultato[i] = ' '; /* I caratteri in eccesso diventano blanks */
    else
      risultato[i] = chiave[i] + casuale[i];
  }

  /* Chiama la funzione hl_code(), che effettua una ulteriore crittografazione */
  strcpy(tmp_res,risultato);
  hl_code(risultato);
  if (strcmp(risultato,tmp_res) == 0)
    return 0; /* Se le stringhe sono uguali significa che la chiave non c'e' o che qualcuno sta
                 cercando di sproteggere il programma */

  /* Ora passiamo la stringa criptata alla DLL per farci restituire l'autorizzazione */
  hl_getstr(risultato);
  
  /* Chiama la funzione hl_code(), che effettua la crittografazione al contrario */
  strcpy(tmp_res,risultato);
  hl_code(risultato);
  if (strcmp(risultato,tmp_res) == 0)
    return 0; /* Se le stringhe sono uguali significa che la chiave non c'e' o che qualcuno sta
                 cercando di sproteggere il programma */

  /* Adesso possiamo estrarre l'autorizzazione */
  /* Ricodifichiamo seguendo il procedimento inverso: */
  /* Sottraiamo i valori  ASCII dal risultato carattere per carattere */
  terzo_carattere  = risultato[2] - stringa_segreta[2];
  ultimo_carattere = risultato[8] - terzo_carattere;

  abilitazione = ultimo_carattere;

  return abilitazione;
}

int PASCAL WinMain(HINSTANCE cur, HINSTANCE prev, LPSTR cmd, int i)
{
  char m[128];
  
/* Visualizza l'autorizzazione per il Modulo 21 */
  wsprintf(m,"Module %d: %d",21,hl_getaut(21));
  MessageBox(NULL,m,"API",MB_OK);

/* Visualizza l'autorizzazione per il Modulo 33 */
  wsprintf(m,"Module %d: %d",33,hl_getaut(33));
  MessageBox(NULL,m,"API",MB_OK);

/* Visualizza l'autorizzazione per il Modulo 7 */
  wsprintf(m,"Module %d: %d",7,hl_getaut(7));
  MessageBox(NULL,m,"API",MB_OK);

  return (1);
}

