#include <confapp.h>
#include <execp.h>

#include "sv0400a.h"

class TParametri_stat : public TConfig_application
{
  bool _recalculated;

protected:
  virtual const char* get_mask_name() const { return "sv0400a"; }
  virtual bool postprocess_config_changed (const char*, const char*, const char*, const char*);

public:
  TParametri_stat();
};

bool TParametri_stat::postprocess_config_changed (const char*, const char*, const char*, const char*)
{
  bool recalc = !_recalculated && yesno_box("Si desidera ricalcolare le statistiche ora?");
  if (recalc)
  {
    TExternal_app app("sv2 -0");
    _recalculated = app.run() == 0;
  }
  return TRUE;
}         

TParametri_stat::TParametri_stat() 
               : TConfig_application(CONFIG_DITTA), _recalculated(FALSE)
{ } 

int sv0400(int argc, char* argv[])
{     
  TParametri_stat app;
  app.run(argc, argv, "Parametri statistiche");
  return 0;
}
