// Form di stampa lista documenti

USE LF_DOC
JOIN LF_RIGHEDOC TO LF_DOC INTO CODNUM==CODNUM ANNO==ANNO PROVV==PROVV NDOC==NDOC
JOIN LF_AGENTI TO LF_DOC INTO CODAGE==CODAG
JOIN %TIP TO LF_DOC ALIAS 201 INTO CODTAB==TIPODOC
JOIN %CPG TO LF_DOC ALIAS 202 INTO CODTAB==CODPAG
JOIN %BAN TO LF_DOC ALIAS 203 INTO CODTAB==CODABIA+CODCABA
END

DESCRIPTION
BEGIN
  33->* "Documenti di vendita"
  20->* "Clienti/Fornitori"
  %TIP->* "Tabella tipi documento"
END

GENERAL
BEGIN
  OFFSET 0 0
END

SECTION GRAPHICS ODD 4
 FIGURA 1 1 1
 BEGIN
  PROMPT 1 1 ""
 END
END

SECTION HEADER ODD 6

STRINGA 1 40 1
BEGIN
 KEY "nome ditta"
 PROMPT  1 1 "Ditta "
 MESSAGE _DITTA, !RAGSOC
END

STRINGA 2 10
BEGIN
 KEY "Data"
 PROMPT  120 1 "Data "
 MESSAGE _TODAY
END

NUMERO 3 7
BEGIN
 KEY "Nr. pagina"
 PROMPT  140 1 "Pagina "
 MESSAGE _PAGENO
END

STRINGA 4 25
BEGIN
 KEY "Intestazione stampa"
 PROMPT  50 2 "Stampa lista documenti"
END

STRINGA 5 157
BEGIN
 KEY "Separatore"
 PROMPT 1 3 ""
 MESSAGE _SEPARATOR,157
END

STRINGA 6 12
BEGIN
  KEY "Intestazione 1"
  PROMPT 1 4 "Cod.num/Tipo"
END

STRINGA 7 10
BEGIN
  KEY "Intestazione 2"
  PROMPT 14 4 "Data doc."
END

STRINGA 8 8
BEGIN
  KEY "Intestazione 3"
  PROMPT 25 4 "Nr. doc."
END

STRINGA 9 5
BEGIN
  KET "Intestazione 4"
  PROMPT 34 4 "Stato"
END

STRINGA 10 8
BEGIN
  KEY "Intestazione 5"
  PROMPT 40 4 "Cod. C/F"
END

STRINGA 11 30
BEGIN
  KEY "Intestazione 6"
  PROMPT 49 4 "Ragione sociale"
END

STRINGA 12 15
BEGIN
  KEY "Intestazione 7"
  PROMPT 80 4 "% Sconto"
END

STRINGA 13 30
BEGIN
  KEY "Intestazione 8"
  PROMPT 96 4 "Cod. Agente"
END

STRINGA 14 30
BEGIN
  KEY "Intestazione 9"
  PROMPT 127 4 "Cod. Pagamento"
END

STRINGA 11 157
BEGIN
 KEY "Separatore"
 PROMPT 1 5 ""
 MESSAGE _SEPARATOR,157
END

END // HEADER


SECTION BODY ODD 6

STRINGA 1 4
BEGIN
 KEY "Estremi cod. num."
 PROMPT  1 1 "@B"
 FIELD LF_DOC->CODNUM
END

STRINGA 2 
BEGIN
  KEY "Estremi tipo doc."
  PROMPT 5 1 "/"
  FIELD LF_DOC->TIPODOC
END

DATA 3 10
BEGIN
 KEY "Data documento"
 PROMPT  14 1 ""
 FIELD 33->DATADOC
END

NUMERO 4 8
BEGIN
 SPECIAL STRINGA INTESTAZIONE "Num.doc." "Numero documento"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Numero documento"
 PROMPT  25 1 ""
 FIELD 33->NDOC
 PICTURE "#######"
END

STRINGA 5 15
BEGIN
 KEY "Stato documento"
 PROMPT  36 1 "@R"
 FIELD 33->STATO
END

NUMERO 6 7
BEGIN
 KEY "Codice C/F"
 PROMPT 41 1 ""
 PICTURE "#######"
 FIELD 33->CODCF
END

STRINGA 7 30
BEGIN
 KEY "Ragione sociale"
 PROMPT  49 1 ""
 MESSAGE _CLIENTE,!RAGSOC
END

STRINGA 8 15
BEGIN
 KEY "Sconto"
 PROMPT  80 1 ""
 FIELD 33->SCONTOPERC
END

STRINGA 9 30
BEGIN
 KEY "Agente"
 PROMPT  96 1 ""
 MESSAGE _STREXPR,33->CODAG+" "+LF_AGENTI->RAGSOC
END

STRINGA 10 30
BEGIN
 KEY "Cod. pagamento"
 PROMPT  127 1 ""
 MESSAGE _STREXPR,33->CODPAG+" "+202@->S0
END

STRINGA 11 15
BEGIN
  KEY "Valuta"
  PROMPT 14 2 "Cod. Valuta "
  FIELD 33->CODVAL
  MESSAGE _EDITPICTURE,22,24,25,27,28,29,31,32,34
END

NUMERO 12 18
BEGIN
  KEY "Cambio"
  PROMPT 30 2 "Cambio "
  FIELD 33->CAMBIO
  PICTURE "###.###,@@@@@@"
END

STRINGA 13 80
BEGIN
  KEY "Banca d'appoggio"
  PROMPT 49 2 ""
  MESSAGE _STREXPR,"Banca App. "+33->CODABIA+"/"+33->CODCABA+" "+203@->S0
END

VALUTA 14 15
BEGIN
  PROMPT 120 2 ""
  FLAGS "H"
  DRIVENBY 11
  FIELD TOTDOC
  MESSAGE COPY,36|COPY,28
END

VALUTA 15 15
BEGIN
  PROMPT 120 2 ""
  FLAGS "H"
  DRIVENBY 11
  MESSAGE _TOTIMPONIBILI,0
  MESSAGE COPY,37
END

SECTION H_RIGHE 3 0 2 GROUP
 FLAGS "D"
  STRINGA 1 20
  BEGIN
    PROMPT 1 1 "Codice articolo"
  END

  STRINGA 2 35
  BEGIN
    PROMPT 23 1 "Descrizione"
  END

  STRINGA 3 4
  BEGIN
    PROMPT 59 1 "UM"
  END

  STRINGA 4 15
  BEGIN
    PROMPT 71 1 "Quantita"
  END

  STRINGA 5 15
  BEGIN
    PROMPT 89 1 "Prezzo"
  END

  STRINGA 16 15
  BEGIN
    PROMPT 104 1 "Importo"
  END

  STRINGA 17 15
  BEGIN
    PROMPT 115 1 "% Sconto"
  END

  STRINGA 18 7
  BEGIN
    PROMPT 130 1 "% Prov"
  END

  STRINGA 19 20
  BEGIN
    PROMPT 137 1 "Val. provvigioni"
  END
  
  STRINGA 20 157
  BEGIN
   KEY "Separatore"
   PROMPT 1 2 ""
   MESSAGE _SEPARATOR,157
  END
END

SECTION RIGHE 3 1 1 FILE LF_RIGHEDOC
  FLAGS "D"

  STRINGA 1 20
  BEGIN
    PROMPT  1 1 ""
    FIELD LF_RIGHEDOC->CODART
    MESSAGE _EDITPICTURE,5,6,9
  END

  STRINGA 2 35
  BEGIN
    PROMPT 23 1 ""
    FIELD LF_RIGHEDOC->DESCR
  END

  STRINGA 3 4
  BEGIN
    PROMPT 59 1 ""
    FIELD LF_RIGHEDOC->UMQTA
  END

  NUMERO 4 15
  BEGIN
    PROMPT 64 1 ""
    FIELD LF_RIGHEDOC->QTA
    PICTURE "#########,@@@@@"
  END

  VALUTA 5 15 
  BEGIN
    PROMPT 84 1 ""
    FIELD LF_RIGHEDOC->PREZZO
    DRIVENBY 11
    FLAGS "U"
  END
  
  VALUTA 6 15
  BEGIN
    PROMPT 100 1 ""
    FIELD LF_RIGHEDOC->IMPNN
    DRIVENBY 11
  END

  STRINGA 7 15 
  BEGIN
    PROMPT 115 1 ""
    FIELD LF_RIGHEDOC->SCONTO
  END

  NUMERO 8 6
  BEGIN
    PROMPT 130 1 ""
    FIELD LF_RIGHEDOC->PERCPROV
    PICTURE "###,@@"
  END

  VALUTA 9 15
  BEGIN
    PROMPT 142 1 ""
    FIELD LF_RIGHEDOC->PROVVR
    DRIVENBY 11
  END
END // SECTION RIGHE

STRINGA 16 113
BEGIN
  KEY "Separatore Totale documento"
  PROMPT 23 3 ""
  MESSAGE _SEPARATOR,113
END

STRINGA 17 18
BEGIN
  KEY "Intestazione Imponibile IVA (1 colonna)"
  PROMPT 23 4 "Imponibile IVA"
END

STRINGA 18 18
BEGIN
  KEY "Intestazione Imposta (1 colonna)"
  PROMPT 53 4 "Imposta"
END

STRINGA 19 18
BEGIN
  KEY "Intestazione Imponibile IVA (2 colonna)"
  PROMPT 75 4 "Imponibile IVA"
END

STRINGA 20 18
BEGIN
  KEY "Intestazione Imposta (2 colonna)"
  PROMPT 106 4 "Imposta"
END

STRINGA 21 18
BEGIN
  KEY "Intestazione Totale documento"
  PROMPT 122 4 "@BTot. documento"
END

// Tabella riepilogativa imponibili per codice IVA

VALUTA 22 18 
BEGIN
 KEY "Imponibile 1"
 PROMPT 22 5 ""
 DRIVENBY 11
 MESSAGE _RIEPILOGOIVA,31,IMP,0
END

STRING 23 4 
BEGIN
 KEY "Codice iva 1"
 PROMPT 42 5 ""
 MESSAGE _RIEPILOGOIVA,31,COD,0
END

VALUTA 24 18 
BEGIN
 KEY "Imposta 1"
 PROMPT 45 5 ""
 MESSAGE _RIEPILOGOIVA,31,IVA,1
 DRIVENBY 11
END

VALUTA 25 18 
BEGIN
 KEY "Imponibile 2"
 PROMPT 74 5 ""
 MESSAGE _RIEPILOGOIVA,31,IMP,0
 DRIVENBY 11
END

STRING 26 4 
BEGIN
 KEY "Codice iva 2"
 PROMPT 94 5 ""
 MESSAGE _RIEPILOGOIVA,31,COD,0
END

VALUTA 27 18 
BEGIN
 KEY "Imposta 2"
 PROMPT 98 5 ""
 MESSAGE _RIEPILOGOIVA,31,IVA,1
 DRIVENBY 11
END

VALUTA 28 18
BEGIN
  KEY "Totale documento"
  PROMPT 121 5 "@B"
  DRIVENBY 11
END

VALUTA 29 18 
BEGIN
 KEY "Imponibile 3"
 PROMPT  25 6 ""
 MESSAGE _RIEPILOGOIVA,1,IMP,0
 DRIVENBY 11
END

STRING 30 4 
BEGIN
 KEY "Codice iva 3"
 PROMPT  44 6 ""
 MESSAGE _RIEPILOGOIVA,1,COD,0
END

VALUTA 31 18 
BEGIN
 KEY "Imposta 3"
 PROMPT  49 6 ""
 MESSAGE _RIEPILOGOIVA,1,IVA,1
 DRIVENBY 11
END

VALUTA 32 18 
BEGIN
 KEY "Imponibile 4"
 PROMPT  78 6 ""
 MESSAGE _RIEPILOGOIVA,1,IMP,0
 DRIVENBY 11
END

STRING 33 4 
BEGIN
 KEY "Codice iva 4"
 PROMPT  97 6 ""
 MESSAGE _RIEPILOGOIVA,1,COD,0
END

VALUTA 34 18 
BEGIN
 KEY "Imposta 4"
 PROMPT  102 6 ""
 MESSAGE _RIEPILOGOIVA,1,IVA,1
 DRIVENBY 11
END

NUMERO 35 1
BEGIN
  KEY "Flag per Calcolo totali in Lire (moltiplica per il cambio)"
  PROMPT 1 7 ""
  FLAGS "H"
END

VALUTA 36 15 
BEGIN
 KEY "Campo nascosto per il calcolo Totale documenti"
 PROMPT  1 7 ""
 MESSAGE _NUMEXPR,IF(((#12!=0)&&(#35==1));#36*#12;#36)
 MESSAGE _LISTADOC,STORE,#1
 MESSAGE _LISTADOC,ADDTOT,FL->16
 FLAGS "H"
 DRIVENBY 11
END

VALUTA 37 15 
BEGIN
 KEY "Campo nascosto per il calcolo Totale imponibili"
 PROMPT  40 7 ""
 MESSAGE _NUMEXPR,IF(((#12!=0)&&(#35==1));#37*#12;#37)
 MESSAGE _LISTADOC,ADDTOT,FL->17
 FLAGS "H"
 DRIVENBY 11
END

END //BODY

SECTION FOOTER ODD 3
END

SECTION FOOTER LAST  11

STRINGA 1 130
BEGIN
  KEY "Separatore Totali"
  PROMPT 1 1 ""
  MESSAGE _SEPARATOR,130
END

STRINGA 2 25
BEGIN
 KEY "TOTALI"
 PROMPT  1 2 "TOTALI"
END

STRINGA 3 20
BEGIN
 KEY "Cod numerazione"
 PROMPT  25 2 "COD. NUMERAZIONE"
END

STRINGA 4 18 
BEGIN
 KEY "Totale Documenti"
 PROMPT  64 2 "TOTALE DOCUMENTI"
END

STRING 5 4
BEGIN
  KEY "Cod. numerazione 1"
  PROMPT 25 3 ""
  MESSAGE _LISTADOC,CODICE,1
END

VALUTA 6 18
BEGIN
  KEY "Tot. Cod. numerazione 1"
  PROMPT 65 3 ""
  MESSAGE _LISTADOC,TOTALE,1
END

STRING 7 4
BEGIN
  KEY "Cod. numerazione 2"
  PROMPT 25 4 ""
  MESSAGE _LISTADOC,CODICE,2
END

VALUTA 8 18
BEGIN
  KEY "Tot. Cod. numerazione 2"
  PROMPT 65 4 ""
  MESSAGE _LISTADOC,TOTALE,2
END

STRING 9 4
BEGIN
  KEY "Cod. numerazione 3"
  PROMPT 25 5 ""
  MESSAGE _LISTADOC,CODICE,3
END

VALUTA 10 18
BEGIN
  KEY "Tot. Cod. numerazione 3"
  PROMPT 65 5 ""
  MESSAGE _LISTADOC,TOTALE,3
END

STRING 11 4
BEGIN
  KEY "Cod. numerazione 4"
  PROMPT 25 6 ""
  MESSAGE _LISTADOC,CODICE,4
END

VALUTA 12 18
BEGIN
  KEY "Tot. Cod. numerazione 4"
  PROMPT 65 7 ""
  MESSAGE _LISTADOC,TOTALE,4
END

STRINGA 13 55
BEGIN
  KEY "Separatore Totali Generali"
  PROMPT 25 8 ""
  MESSAGE _SEPARATOR,55
END

STRINGA 14 20
BEGIN
  KEY "TOTALE GENERALE"
  PROMPT 25 9 "@BTOTALE GENERALE"
END

STRINGA 15 22
BEGIN
  KEY "TOTALE IMPONIBILI"
  PROMPT 25 10 "@BTOTALE IMPONIBILI"
END

VALUTA 16 18
BEGIN
 KEY "Totale Generale"
 PROMPT  65 9 ""
END

VALUTA 17 18
BEGIN
 KEY "Totale Imponibili"
 PROMPT  65 10 ""
END

END // FOOTER


