// Form per la stampa delle condizioni di vendita,
// Listini/Contratti/Offerte

USE LF_CONDV
JOIN LF_RCONDV INTO TIPO==TIPO CATVEN==CATVEN TIPOCF==TIPOCF CODCF==CODCF COD==COD
JOIN LF_ANAMAG TO LF_RCONDV INTO CODART==CODRIGA
JOIN GMC TO LF_RCONDV ALIAS 101 INTO CODTAB==CODRIGA
JOIN RFA TO LF_RCONDV ALIAS 102 INTO CODTAB==CODRIGA
END

DESCRIPTION
BEGIN
  LF_CONDV->* "Archivio Condizioni di Vendita"
  LF_RCONDV->* "Archivio Righe Condizioni di Vendita"
END

GENERAL
BEGIN
  OFFSET 0 0
END

SECTION HEADER ODD 7

STRINGA 1 40 1
BEGIN
 KEY "nome ditta"
 PROMPT  1 1 "Ditta "
 MESSAGE _DITTA, !RAGSOC
END

STRINGA 2 10
BEGIN
 KEY "Data"
 PROMPT  100 1 "Data "
 MESSAGE _TODAY
END

NUMERO 3 7
BEGIN
 KEY "Nr. pagina"
 PROMPT  120 1 "Pagina "
 MESSAGE _PAGENO
END

LISTA 4 15
BEGIN
 KEY "Intestazione stampa"
 PROMPT  65 2 ""
 FIELD LF_CONDV->TIPO
 ITEM "L|Stampa listino"
 ITEM "C|Stampa contratto"
 ITEM "O|Stampa offerta"
END

STRINGA 5 12
BEGIN
  KEY "Cat. vendita"
  PROMPT 1 3 "Cat. ven: "
  FIELD LF_CONDV->CATVEN
  FLAGS "H"
END

LISTA 6 10
BEGIN
  KEY "Tipo C/F"
  PROMPT 1 3 ""
  ITEM "|"
  ITEM "C|Cliente"
  ITEM "F|Fornitore"
  FIELD LF_CONDV->TIPOCF
  FLAGS "H"
END

NUMBER 7 6
BEGIN
 KEY "Codice C/F"
 PROMPT 11 3 ""
 FIELD LF_CONDV->CODCF
 FLAGS "H"
END

STRINGA 8 11
BEGIN
  KEY "Codice Listino/Contratto/Offerta"
  PROMPT 20 3 "@BCodice: "
  FIELD LF_CONDV->COD
END

STRINGA 9 50
BEGIN
  KEY "Descrizione"
  PROMPT 34 3 ""
  FIELD LF_CONDV->DESCR
END

STRINGA 10 12
BEGIN
  KEY "Cod. Valuta"
  PROMPT 1 4 "Valuta: "
  FIELD LF_CONDV->CODVAL
END

DATA 11 23
BEGIN
  KEY "Inizio validita"
  PROMPT 15 4 "Inizio val.: "
  FIELD LF_CONDV->VALIN
END

DATA 13 23
BEGIN
  KEY "Fine validita"
  PROMPT 40 4 "Fine  val.: "
  FIELD LF_CONDV->VALFIN
END

LISTA 14 20
BEGIN
  KEY "Importi Lordi"
  PROMPT 65 4 ""
  FIELD LF_CONDV->IMPLORDI
  ITEM "|Listino senza IVA"
  ITEM "X|Listino con IVA"
END

END // HEADER


SECTION BODY ODD 2 COLUMNWISE

// Intestazioni colonne

STRINGA 1 20
BEGIN
 SPECIAL STRINGA INTESTAZIONE "Codice" "Codice"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Codice riga"
 PROMPT 1 1 ""
END

STRINGA 2 25
BEGIN
 SPECIAL STRINGA INTESTAZIONE "Descrizione" "Descrizione"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Descrizione"
 PROMPT 2 1 ""
END

STRINGA 3 4
BEGIN
 SPECIAL STRINGA INTESTAZIONE "UM" "UM"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Unita' di misura"
 PROMPT 3 1 ""
END

STRINGA 4 15
BEGIN
 SPECIAL STRINGA INTESTAZIONE "@CDa qta" "Da qta"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Qta lim da"
 PROMPT 4 1 ""
END

STRINGA 5 15
BEGIN
 SPECIAL STRINGA INTESTAZIONE "@CA qta" "A qta"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Qta lim a"
 PROMPT 5 1 ""
END

STRINGA 6 15
BEGIN
 SPECIAL STRINGA INTESTAZIONE "@CPrezzo" "Prezzo"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Prezzo"
 PROMPT 6 1 ""
END

STRINGA 7 25
BEGIN
 SPECIAL STRINGA INTESTAZIONE "@CSconto" "Sconto"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Sconto"
 PROMPT 7 1 ""
END

STRINGA 8 4 
BEGIN
 SPECIAL STRINGA INTESTAZIONE "@CIVA" "IVA"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Codice IVA"
 PROMPT 8 1 ""
END

STRINGA 9 15
BEGIN
 SPECIAL STRINGA INTESTAZIONE "@CQta base" "Qta base"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Qta base per calcolo sconto"
 PROMPT 9 1 ""
END

STRINGA 10 15
BEGIN
 SPECIAL STRINGA INTESTAZIONE "@CQta omaggio" "Qta omaggio"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Qta Omaggio"
 PROMPT 10 1 ""
END

STRINGA 11 20
BEGIN
 SPECIAL STRINGA INTESTAZIONE "@CCod. art. Omaggio" "Cod. Art. Omaggio"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Cod. articolo omaggio"
 PROMPT 11 1 ""
END

// Sezione di stampa righe 

SECTION RIGHE 1 1 1 FILE LF_RCONDV
  
  SECTION H_RIGHE 1 1 1 GROUP
  
  STRINGA 101 20
  BEGIN
    KEY "Codice riga"
    PROMPT 1 1 "@B"
    FIELD LF_RCONDV->CODRIGA
  END
  
  STRINGA 102 25 2
  BEGIN
    KEY "Descrizione"
    PROMPT 2 1 ""
    MESSAGE _DESCRIZIONE
  END
  END
  
  SECTION GR_RIGHE 1 1 1 FILE LF_RCONDV GROUP TIPORIGA+CODRIGA
  
    STRINGA 201 20
    BEGIN
      PROMPT 1 1 ""
      FLAGS "D"
    END
    
    STRINGA 202 25
    BEGIN
      PROMPT 2 1 ""
      FLAGS "D"
    END
    
    STRINGA 103 4
    BEGIN
      KEY "UM"
      PROMPT 3 1 ""
      FIELD LF_RCONDV->UM
    END
    
    NUMERO 104 15
    BEGIN
      KEY "Qta lim da"
      PROMPT 4 1 ""
      MESSAGE _QTAFROM
    END
    
    NUMERO 105 15
    BEGIN
      KEY "Qta lim a"
      PROMPT 5 1 ""
      MESSAGE _QTATO
    END
    
    NUMERO 106 15
    BEGIN
      KEY "Prezzo"
      PROMPT 6 1 ""
      FIELD LF_RCONDV->PREZZO
    END
    
    STRINGA 107 25
    BEGIN
      KEY "Sconto"
      PROMPT 7 1 ""
      FIELD LF_RCONDV->SCONTO
    END
    
    STRINGA 108 4
    BEGIN
      KEY "Cod. IVA"
      PROMPT 8 1 ""
      FIELD LF_RCONDV->CODIVA
    END
  
    NUMERO 109 15
    BEGIN
      KEY "Qta base per calcolo sconto"
      PROMPT 9 1 ""
      FIELD LF_RCONDV->QBASE
      PICTURE "#########@,@@@@@"
    END
    
    NUMERO 110 15
    BEGIN
      KEY "Qta omaggio"
      PROMPT 10 1 ""
      FIELD LF_RCONDV->QOM
      PICTURE "#########@,@@@@@"
    END
  
    STRINGA 111 20
    BEGIN
      KEY "Cod. articolo Omaggio"
      PROMPT 11 1 ""
      FIELD LF_RCONDV->CODARTOM
    END
  END // SECTION
END // SECTION

END // BODY

END // FORM

