USE 33
JOIN 34 INTO CODNUM==CODNUM ANNO==ANNO PROVV==PROVV NDOC==NDOC
JOIN 17 TO 33 INTO TIPOCF==TIPOCF CODCF==CODCF
JOIN 20 TO 33 INTO TIPOCF==TIPOCF CODCF==CODCF
JOIN 16 TO 33 INTO TIPOCF==TIPOCF CODCF==CODCF CODIND==CODINDSP
JOIN 16 TO 17 ALIAS 116 INTO TIPOCF==TIPOCF CODCF==CODCF CODIND==CODINDSP
JOIN 47 TO 34 INTO CODART==CODART
JOIN %CPG TO 33 ALIAS 201 INTO CODTAB==CODPAG
JOIN 122 TO 33  INTO CODAGE==CODAG
JOIN %POR TO 33 ALIAS 203 INTO CODTAB==CODPORTO
JOIN %BAN TO 33 ALIAS 204 INTO CODTAB==CODABIA+CODCABA
JOIN %VET TO 33 ALIAS 205 INTO CODTAB==CODVETT1
JOIN %ABE TO 33 ALIAS 206 INTO CODTAB==ASPBENI1
JOIN %CTR TO 33 ALIAS 207 INTO CODTAB==CAUSTRASP
JOIN %TIP TO 33 ALIAS 208 INTO CODTAB==TIPODOC
JOIN %BAN TO 33 ALIAS 209 INTO CODTAB==CODABIA
JOIN %NDO TO 33 ALIAS 210 INTO CODTAB==CODNOTESP1

END

DESCRIPTION
BEGIN
  34->* "Righe documenti di vendita"
  33->* "Documenti di vendita"
  17->* "Clienti/Fornitori per vendite"
  20->* "Clienti/Fornitori"
  16->* "Indirizzi di spedizione (destinazione)"
  116@->* "Indirizzi di spedizione (destinatario)"
  47->* "Anagrafica magazzino"
  201@->* "Tabella condizioni di pagamento"
  122->* "Archivio agenti"
  203@->* "Tabella porto"
  204@->* "Tabella banche"
  205@->* "Tabella vettori"
  206@->* "Tabella aspetto beni"
END

GENERAL
BEGIN
  OFFSET 0 0
  FONT "Roman 10cpi"
  SIZE 10
  MODULE "BUFFETTI_FATTURA_8903 D 300"
  PRI_DECIMALS 0 2
  QTA_DECIMALS 3 3
  IMP_DECIMALS 0 2
  EXCLUDE "08,"
END


SECTION HEADER ODD 25

STRINGA 200 1 
BEGIN
 KEY "abilita/disabilita stampa intestazione ditta "
 PROMPT  1 1 ""
 MESSAGE ENABLE,15@
 FLAGS "H"
END

STRINGA 1 35 1
BEGIN
 KEY "nome ditta"
 PROMPT  3 4 ""
 MESSAGE _DITTA,!RAGSOC
 GROUP 15
 FLAGS "D"
END

STRINGA 2 35 1
BEGIN
 KEY "indirizzo ditta"
 PROMPT  3 5 ""
 MESSAGE _DITTA,!IND
 GROUP 15
 FLAGS "D"
END

STRINGA 3 5 1
BEGIN
 KEY "cap ditta"
 PROMPT  3 6 ""
 MESSAGE _DITTA,!CAP
 GROUP 15
 FLAGS "D"
END

STRINGA 4 30 1
BEGIN
 KEY "comune ditta"
 PROMPT  10 6 ""
 MESSAGE _DITTA,!COM
 GROUP 15
 FLAGS "D"
END

STRINGA 5 8 1
BEGIN
 KEY "scritta P.IVA"
 PROMPT  3 7 "P.IVA IT"
 GROUP 15
 FLAGS "D"
END

STRINGA 6 16 1
BEGIN
 KEY "partita iva ditta"
 PROMPT  12 7 ""
 MESSAGE _DITTA,!IVA
 GROUP 15
 FLAGS "D"
END

STRINGA 7 12 1
BEGIN
 KEY "scritta COD.FISC."
 PROMPT  3 8 "COD.FISC. IT"
 GROUP 15
 FLAGS "D"
END

STRINGA 8 16 1
BEGIN
 KEY "codice fiscale ditta"
 PROMPT  16 8 ""
 MESSAGE _DITTA,!CF
 GROUP 15
 FLAGS "D"
END

LIST 9 1 1
BEGIN
 KEY "fattura"
 PROMPT 38 4 ""
 FIELD 208@->I1
 ITEM "|" 
 ITEM "1| "
 ITEM "2|X" 
 ITEM "3| "
END

LIST 10 1 1
BEGIN
 KEY "d.d.t."
 PROMPT 38 6 ""
 FIELD 208@->I1
 ITEM "|" 
 ITEM "1|X" 
 ITEM "2| "
 ITEM "3| "
END

DATA 11 8 1
BEGIN
 KEY "data fattura"
 PROMPT  60 19 ""
 FIELD 33->DATADOC
 FORMAT "1442-"
END

STRINGA 12 7
BEGIN
 KEY "numero fattura"
 PROMPT  71 19 ""
 FIELD 33->NDOC
END

STRINGA 13 2
BEGIN
 KEY "Numero di pagina"
 PROMPT  80 19 ""
 MESSAGE _PAGENO
END

STRING 14 30 1
BEGIN
 KEY "tipo di documento"
 PROMPT 2 19 ""
 FIELD 208@->S0 
END

STRINGA 15 5  
BEGIN
 KEY "codice cliente"
 PROMPT  2 21 ""
 FIELD 33->CODCF
END

STRINGA 16 3 
BEGIN
 KEY "codice agente"
 PROMPT  8 21 ""
 FIELD 33->CODAG
END

NUMERO 17 6 
BEGIN
 KEY "ordine"
 PROMPT  12 21 ""
 FIELD 33->NUMDOCRIF
END

DATA 18 8 
BEGIN
 KEY "data conferma"
 PROMPT  19 21 ""
 FIELD 33->DATADOCRIF
 FORMAT "1442-"
END

STRING 19 11 
BEGIN
 KEY "copy partita iva"
 PROMPT 1 1 ""
 MESSAGE _CLIENTE,PAIV
 MESSAGE COPY,20
 FLAGS "H"
END

STRING 20 11 
BEGIN
 KEY "test PIVA/CF"
 PROMPT 1 1 ""
 MESSAGE EMPTY ENABLE,22
 MESSAGE ENABLE,21
 FLAGS "H"
END

STRING 21 11 
BEGIN
 KEY "partita iva cliente"
 PROMPT 37 21 ""
 MESSAGE _CLIENTE,PAIV
 FLAGS "D"
END

STRING 22 16 1
BEGIN
 KEY "codice fiscale cliente"
 PROMPT 35 21 ""
 MESSAGE _CLIENTE,COFI
 FLAGS "D"
END

STRING 23 2 
BEGIN
 KEY "codice iso iva cliente"
 PROMPT 35 21 ""
 MESSAGE _CLIENTE,STATOPAIV
 FLAGS "D"
END

STRINGA 24 14 
BEGIN
 KEY "porto"
 PROMPT  52 21 ""
 FIELD 203@->S0
END

STRING 25 15 
BEGIN
 KEY "causale di trasporto"
 PROMPT 67 21 ""
 FIELD 207@->S0
END

STRINGA 26 50 
BEGIN
 KEY "condizioni di pagamento"
 PROMPT  2 23 ""
 FIELD 201@->S0
END

STRINGA 27 29 
BEGIN
 KEY "banca d'appoggio istituto"
 PROMPT  53 23 ""
 FIELD 209@->S0
END

STRINGA 28 29 
BEGIN
 KEY "banca d'appoggio agenzia"
 PROMPT  53 23 ""
 FIELD 204@->S0
 FLAGS "D"
END

STRING 29 35 2
BEGIN
 KEY "destinatario, ditta"
 PROMPT 44 12 ""
 MESSAGE _CLIENTE,!RAGSOC
END

STRING 30 35 2
BEGIN
 KEY "destinatario, indirizzo con numero civico"
 PROMPT 44 14 ""
 MESSAGE _CLIENTE,!INDNUM
END

STRING 31 35 1
BEGIN
 KEY "destinatario, localita"
 PROMPT 44 16 ""
 MESSAGE _CLIENTE,LOCALITACF
END

STRING 32 5 1
BEGIN
 KEY "destinatario, cap"
 PROMPT 44 17 ""
 MESSAGE _CLIENTE,!CAP
END

STRING 33 30 1
BEGIN
 KEY "destinatario, comune"
 PROMPT 50 17 ""
 MESSAGE _CLIENTE,!COM->DENCOM
 MESSAGE COPY,35
 FLAGS "H"
END

STRING 34 2 
BEGIN
 KEY "destinatario, provincia"
 PROMPT 73 17 ""
 MESSAGE _CLIENTE,!COM->PROVCOM
 MESSAGE APPEND,35
 FLAGS "H"
END

STRINGA 35 30 1
BEGIN
 KEY "cliente comune+prov."
 PROMPT  50 17 ""
END

STRING 36 5 
BEGIN
 KEY "test indirizzo di spedizione"
 PROMPT 1 1 ""
 FLAGS "H"
 FIELD CODINDSP
 MESSAGE EMPTY ENABLE,10@|DISABLE,11@|DISABLE,48
 MESSAGE DISABLE,10@|ENABLE,11@|DISABLE,48
END

STRING 37 30 2
BEGIN
 KEY "destinazione, ragione sociale"
 PROMPT 3 12 ""
 FIELD 16->RAGSOC
 GROUP 11
 FLAGS "D"
END

STRING 38 30 2
BEGIN
 KEY "destinazione, indirizzo"
 PROMPT 3 14 ""
 FIELD 16->INDIR
 MESSAGE COPY,40
 FLAGS "H"
END

STRING 39 10 1
BEGIN
 KEY "destinazione, indirizzo"
 PROMPT 3  14 ""
 FIELD 16->CIV
 MESSAGE APPEND,40
 FLAGS "H"
END

STRING 40 35 2
BEGIN
 KEY "destinazione, indirizzo+N.civico"
 PROMPT 3  14 ""
 GROUP 11
 FLAGS "D"
END

STRING 41 35 1
BEGIN
 KEY "destinazione, localita"
 PROMPT 3  16 ""
 FIELD 16->LOCALITA
 GROUP 11
 FLAGS "D"
END

STRING 42 5  
BEGIN
 KEY "destinazione, cap"
 PROMPT 3 17 ""
 FIELD 16->CAP
 GROUP 11
 FLAGS "D"
END

STRING 43 5 
BEGIN
 KEY ""
 PROMPT 1 1 ""
 FLAGS "H"
 FIELD 16->COM
END

STRING 44 21 2 
BEGIN
 KEY "destinazione, comune"
 PROMPT 9 17 ""
 MESSAGE _ISAMREAD,13,COM=#43,DENCOM
 MESSAGE COPY,46
 FLAGS "H"
END

STRING 45 2 
BEGIN
 KEY "destinazione, provincia"
 PROMPT 31 17 ""
 MESSAGE _ISAMREAD,13,COM=#43,PROVCOM
 MESSAGE APPEND,46
 FLAGS "H"
END

STRING 46 27 1 
BEGIN
 KEY "destinazione, comune+provincia"
 PROMPT 9 17 ""
 GROUP 11
 FLAGS "D"
END

STRING 48 30 1
BEGIN
 KEY "destinazione, idem"
 PROMPT 3 12 "IDEM"
 FLAGS "D"
END

STRING 49 35 2
BEGIN
 KEY "destinatario, ditta dest"
 PROMPT 3 12 ""
 MESSAGE _CLIENTE,!RAGSOC
 GROUP 10
 FLAGS "D"
END

STRING 50 35 2
BEGIN
 KEY "destinatario, indirizzo con numero civico dest"
 PROMPT 3 14 ""
 MESSAGE _CLIENTE,!INDNUM
 GROUP 10
 FLAGS "D"
END

STRING 51 35 1
BEGIN
 KEY "destinatario, localita"
 PROMPT 3 16 ""
 MESSAGE _CLIENTE,LOCALITACF
 GROUP 10
 FLAGS "D"
END

STRING 52 5 1
BEGIN
 KEY "destinatario, cap dest"
 PROMPT 3 17 ""
 MESSAGE _CLIENTE,CAPCF
 GROUP 10
 FLAGS "D"
END

STRING 53 21 1
BEGIN
 KEY "destinatario, comune dest"
 PROMPT 9 17 ""
 MESSAGE _CLIENTE,!COM->DENCOM
 FLAGS "H"
 MESSAGE COPY,55 
END

STRING 54 2 
BEGIN
 KEY "destinatario, provincia dest"
 PROMPT 31 17 ""
 MESSAGE _CLIENTE,!COM->PROVCOM
 FLAGS "H"
 MESSAGE APPEND,55
END

STRING 55 21 1
BEGIN
 KEY "destinatario, comune dest + prov"
 PROMPT 9 17 ""
 FLAGS "D"
 GROUP 10
END

STRINGA 56 3 1
BEGIN
 KEY "cliente codice stato"
 PROMPT  44 17 ""
 MESSAGE _CLIENTE,STATOCF
 FLAGS "D"
END

STRINGA 57 25 1
BEGIN
 KEY "cliente nome stato"
 PROMPT  44 17 ""
 MESSAGE _TABLEREAD,%STA,#26,S0
 FLAGS "D"
END

END

SECTION BODY ODD 5

STRINGA 81 12 1
BEGIN
 KEY "codice articolo"
 FIELD 34->CODART
 PROMPT  2 1 ""
END

STRINGA 82 20 20
BEGIN
 KEY "descrizione articolo"
 MESSAGE _DESCRIGA
 PROMPT  16 1 ""
END

STRINGA 83 2
BEGIN
 KEY "unita' di misura"
 PROMPT  37 1 ""
 FIELD 34->UMQTA
 MESSAGE _ALIGN,#82,BOTTOM
END

NUMBER 84 9
BEGIN
 KEY "quantita'"
 PROMPT  41 1 ""
 FIELD 34->QTA
 PICTURE "#########"
 GROUP 30
 MESSAGE _ALIGN,#82,BOTTOM
END

NUMBER 85 12
BEGIN
 KEY "prezzo unitario"
 PROMPT  51 1 ""
 FIELD 34->PREZZO
 PICTURE "###.###.###"
 GROUP 29
 MESSAGE _ALIGN,#82,BOTTOM
END

STRINGA 86 3
BEGIN
 KEY "sconto"
 PROMPT  63 1 ""
 FIELD 34->SCONTO
 MESSAGE _ALIGN,#82,BOTTOM
END

NUMBER 87 12
BEGIN
 KEY "importo netto"
 PROMPT  67 1 ""
 FIELD 34->IMPNN
 PICTURE "###.###.###"
 GROUP 29
 MESSAGE _ALIGN,#82,BOTTOM
END

STRINGA 88 3 
BEGIN
 KEY "iva"
 PROMPT  80 1 ""
 FIELD 34->CODIVA
 MESSAGE _ALIGN,#82,BOTTOM
END

NUMBER 89 12
BEGIN
 KEY "prezzo unitario scontato"
 PROMPT  67 1 ""
 PICTURE "###.###.###"
 FIELD 34->IMPNS
 GROUP 29
 MESSAGE _ALIGN,#82,BOTTOM
 FLAGS "H"
END

NUMBER 90 15
BEGIN
 KEY "provvigione"
 PROMPT  68 1 ""
 PICTURE "###.###.###.###"
 FIELD 34->PROVVR
 MESSAGE _ALIGN,#82,BOTTOM
 GROUP 31
 FLAGS "H"
END

NUMBER 91 15
BEGIN
 KEY "Imposta"
 PROMPT  68 1 ""
 PICTURE "###.###.###.###"
 FIELD 34->IMPOSTA
 MESSAGE _ALIGN,#82,BOTTOM
 GROUP 31
 FLAGS "H"
END

END

SECTION FOOTER ODD -42

STRINGA 100 5 1
BEGIN
 KEY "stampa 'segue' in coda"
 PROMPT  73 13 "SEGUE"
END

END

SECTION FOOTER LAST -42

NUMBER 101 12 
BEGIN
 KEY "totale importi netti (non scontati)"
 PROMPT  2 3 ""
 FIELD TOTMER
 PICTURE "###.###.###"
 GROUP 31
END

STRINGA 102 7
BEGIN
 KEY "sconto percentuale"
 PROMPT 19 3 ""
 FIELD 33->SCONTOPERC
END

NUMBER 103 11
BEGIN
 KEY "totali sconti"
 PROMPT 27 3 ""
 FIELD SCONTOT
 PICTURE "###.###.###"
 GROUP 31
END

NUMBER 104 11 
BEGIN
 KEY "spese di trasporto"
 PROMPT  42 3 ""
 PICTURE "###.###.###"
 FIELD SPESTRA
 GROUP 31
END

NUMBER 105 11 
BEGIN
 KEY "spese di imballo"
 PROMPT  55 3 ""
 PICTURE "###.###.###"
 FIELD SPESIMB
 GROUP 31
END

NUMBER 106 11 
BEGIN
 KEY "acconto"
 PROMPT  55 6 ""
 PICTURE "###.###.###"
 FIELD IMPPAGATO
 GROUP 31 
END

STRING 107 3 
BEGIN
 KEY "codice iva 1"
 PROMPT  2 5 ""
 MESSAGE _RIEPILOGOIVA,1,COD,0
END

NUMBER 108 12 
BEGIN
 KEY "imponibile 1"
 PROMPT  6 5 ""
 MESSAGE _RIEPILOGOIVA,1,IMP,0
 PICTURE "###.###.###"
 GROUP 31
END

NUMBER 109 2 
BEGIN
 KEY "iva 1"
 PROMPT  19 5 ""
 MESSAGE _RIEPILOGOIVA,1,ALI,0
 PICTURE "##"
END

NUMBER 110 10 
BEGIN
 KEY "imposta 1"
 PROMPT  22 5 ""
 MESSAGE _RIEPILOGOIVA,1,IVA,1
 PICTURE "##.###.###"
 GROUP 31
END

STRING 111 3 
BEGIN
 KEY "codice iva 2"
 PROMPT  2 6 ""
 MESSAGE _RIEPILOGOIVA,1,COD,0
END

NUMBER 112 12 
BEGIN
 KEY "imponibile 2"
 PROMPT  6 6 ""
 MESSAGE _RIEPILOGOIVA,1,IMP,0
 PICTURE "###.###.###"
 GROUP 31
END

NUMBER 113 2 
BEGIN
 KEY "iva 2"
 PROMPT  19 6 ""
 MESSAGE _RIEPILOGOIVA,1,ALI,0
 PICTURE "##"
END

NUMBER 114 10 
BEGIN
 KEY "imposta 2"
 PROMPT  22 6 ""
 MESSAGE _RIEPILOGOIVA,1,IVA,1
 PICTURE "##.###.###"
 GROUP 31
END

STRING 115 3 
BEGIN
 KEY "codice iva 3"
 PROMPT  2 7 ""
 MESSAGE _RIEPILOGOIVA,1,COD,0
END

NUMBER 116 12 
BEGIN
 KEY "imponibile 3"
 PROMPT  6 7 ""
 MESSAGE _RIEPILOGOIVA,1,IMP,0
 PICTURE "###.###.###"
 GROUP 31
END

NUMBER 117 2 
BEGIN
 KEY "iva 3"
 PROMPT  19 7 ""
 MESSAGE _RIEPILOGOIVA,1,ALI,0
 PICTURE "##"
END

NUMBER 118 10 
BEGIN
 KEY "imposta 3"
 PROMPT  22 7 ""
 MESSAGE _RIEPILOGOIVA,1,IVA,1
 PICTURE "##.###.###"
 GROUP 31
END

NUMBER 119 12
BEGIN
 KEY "imponibile 4"
 PROMPT  6 9 ""
 MESSAGE _RIEPILOGOIVA,30,IMP,0
 PICTURE "###.###.###"
 GROUP 31
END

STRINGA 120 3 
BEGIN
 KEY "codice iva 4"
 PROMPT  2 9 ""
 MESSAGE _RIEPILOGOIVA,30,COD,0
END

STRINGA 121 45 
BEGIN
 KEY "descrizione altri 4"
 PROMPT  35 9 ""
 MESSAGE _RIEPILOGOIVA,30,DES,1
END

NUMBER 122 12 
BEGIN
 KEY "imponibile 5"
 PROMPT  6 10 ""
 MESSAGE _RIEPILOGOIVA,30,IMP,0
 PICTURE "###.###.###"
 GROUP 31
END

STRINGA 123 3 
BEGIN
 KEY "codice iva 5"
 PROMPT  2 10 ""
 MESSAGE _RIEPILOGOIVA,30,COD,0
END

STRINGA 124 45 
BEGIN
 KEY "descrizione altri 5"
 PROMPT  35 10 ""
 MESSAGE _RIEPILOGOIVA,30,DES,1
END

NUMBER 125 12 
BEGIN
 KEY "totale imponibile"
 PROMPT  6 13 ""
 MESSAGE _TOTIMPONIBILI,29
 PICTURE "###.###.###"
 GROUP 31
END

NUMBER 126 11 
BEGIN
 KEY "totale imposta"
 PROMPT  21 13 ""
 FIELD IMPOSTE
 PICTURE "###.###.###"
 GROUP 31
END

NUMBER 127 11 
BEGIN
 KEY "totale esenti"
 PROMPT  35 13 ""
 MESSAGE _TOTIMPONIBILI,28
 PICTURE "###.###.###"
 GROUP 31
END

NUMBER 128 7 
BEGIN
 KEY "spese di incasso"
 PROMPT  55 13 ""
 PICTURE "###.###"
 FIELD SPESINC
 GROUP 31
END

NUMBER 129 5 
BEGIN
 KEY "spese bolli"
 PROMPT  63 13 ""
 PICTURE "#####"
 FIELD BOLLI
 GROUP 31
END

NUMBER 130 12 
BEGIN
 KEY "totale fattura"
 PROMPT  70 13 ""
 FIELD TOTDOC
 PICTURE "###.###.###"
 GROUP 31
 MESSAGE COPY,133
END

NUMBER 132 12 
BEGIN
 KEY "acconto"
 PROMPT  70 15 ""
 FIELD 33->IMPPAGATO
 PICTURE "###.###.###"
 GROUP 31
 MESSAGE SUB,133
END

NUMBER 133 12 
BEGIN
 KEY "netto a pagare"
 PROMPT  70 20 ""
 PICTURE "###.###.###"
 GROUP 31
END

DATA 136 8 
BEGIN
 KEY "scadenza pagamento 1"
 PROMPT  2 25 ""
 MESSAGE _SCADENZE,DATA,0
 FORMAT "1442-"
END

NUMBER 137 11 
BEGIN
 KEY "importo scadenza 1"
 PROMPT  11 25 ""
 MESSAGE _SCADENZE,IMPORTO,1
 PICTURE "###.###.###"
 GROUP 31
END

DATA 138 8 
BEGIN
 KEY "scadenza pagamento 2"
 PROMPT  23 25 ""
 MESSAGE _SCADENZE,DATA,0
 FORMAT "1442-"
END

NUMBER 139 11
BEGIN
 KEY "importo scadenza 2"
 PROMPT  32 25 ""
 MESSAGE _SCADENZE,IMPORTO,1
 PICTURE "###.###.###"
 GROUP 31
END
        
DATA 140 8 
BEGIN
 KEY "scadenza pagamento 3"
 PROMPT  44 25 ""
 MESSAGE _SCADENZE,DATA,0
 FORMAT "1442-"
END

NUMBER 141 11 
BEGIN
 KEY "importo scadenza 3"
 PROMPT  53 25 ""
 MESSAGE _SCADENZE,IMPORTO,1
 PICTURE "###.###.###"
 GROUP 31
END

DATA 142 8 
BEGIN
 KEY "scadenza pagamento 4"
 PROMPT  65 25 ""
 MESSAGE _SCADENZE,DATA,0
 FORMAT "1442-"
END

NUMBER 143 11 
BEGIN
 KEY "importo scadenza 4"
 PROMPT  74 25 ""
 MESSAGE _SCADENZE,IMPORTO,1
 PICTURE "###.###.###"
 GROUP 31
END

DATA 144 8 
BEGIN
 KEY "scadenza pagamento 5"
 PROMPT  23 26 ""
 MESSAGE _SCADENZE,DATA,0
 FORMAT "1442-"
 FLAGS "D"
END

NUMBER 145 11 
BEGIN
 KEY "importo scadenza 5"
 PROMPT  32 26 ""
 MESSAGE _SCADENZE,IMPORTO,1
 PICTURE "###.###.###"
 GROUP 31
 FLAGS "D"
END

LIST 146 1 1
BEGIN
 KEY "trasporto a cura del mittente"
 PROMPT 3 16 ""
 FIELD CODSPMEZZO
 ITEM "|" MESSAGE DISABLE,6@|ENABLE,5@
 ITEM "D| "
 ITEM "M|X" MESSAGE DISABLE,6@|ENABLE,5@
 ITEM "V| "
END

LIST 147 1 1
BEGIN
 KEY "trasporto a cura del destinatario"
 PROMPT 11 16 ""
 FIELD CODSPMEZZO
 ITEM "|" MESSAGE DISABLE,6@|ENABLE,5@
 ITEM "D|X" MESSAGE DISABLE,6@|ENABLE,5@
 ITEM "M| "
 ITEM "V| "
END

LIST 148 1 1
BEGIN
 KEY "trasporto a cura del vettore"
 PROMPT 20 16 ""
 FIELD CODSPMEZZO
 ITEM "|" // default
 ITEM "D| "
 ITEM "M| "
 ITEM "V|X" MESSAGE DISABLE,5@|ENABLE,6@
END

STRING 149 20 1
BEGIN
 KEY "aspetto beni"
 PROMPT 31 16 ""
 FIELD 206@->S0
END

STRING 150 7 1
BEGIN
 KEY "peso"
 PROMPT 62 16 ""
 FIELD PNETTO
END

STRING 151 5 1
BEGIN
 KEY "colli"
 PROMPT 54 16 ""
 FIELD NCOLLI
END

STRING 152 35 1
BEGIN
 KEY "nome vettore"
 PROMPT 3 18 ""
 FIELD 205@->S0
END

STRING 153 35 1
BEGIN
 // nella versione 05 togliere MESSAGE COPY
 KEY "indirizzo vettore"
 PROMPT 3 19 ""
 FIELD 205@->S1[1,35]
 MESSAGE COPY,156
 FLAGS "H"
END

STRING 154 35 1
BEGIN
 // nella versione 05 sostituire FLAGS "D" con FLAGS "H"
 KEY "indirizzo vettore"
 PROMPT 3 19 ""
 MESSAGE _STREXPR,TRIM(#153)
 FLAGS "D"
 MESSAGE COPY,156
END

STRING 155 10 1
BEGIN
 KEY "num.civico vettore"
 PROMPT 3 19 ""
 FIELD 205@->S1[36,45]
 MESSAGE APPEND,156
 FLAGS "H"
END

STRING 156 35 1
BEGIN
 KEY "indirizzo vettore+num.civico"
 PROMPT 3 19 ""
END

STRING 157 35 1
BEGIN
 KEY "localita' vettore"
 PROMPT 3 20 ""
 FIELD 205@->S1[46,70]
 FLAGS "D"
END

STRING 158 5 
BEGIN
 KEY "CAP vettore"
 PROMPT 3 20 ""
 FIELD 205@->S7
END

STRING 159 5 1
BEGIN
 KEY "Codice comune vettore"
 PROMPT 1 1 ""
 FIELD 205@->S9
 FLAGS "H"
END

STRING 160 25 1
BEGIN
 KEY "Denominazione comune vettore"
 PROMPT 9 20 ""
 MESSAGE _ISAMREAD,13,COM=#159,DENCOM
 MESSAGE COPY,162
 FLAGS "H"
END

STRING 161 2 
BEGIN
 KEY "Provincia comune vettore"
 PROMPT 37 20 ""
 MESSAGE _ISAMREAD,13,COM=#159,PROVCOM
 MESSAGE APPEND,162
 FLAGS "H"
END


STRING 162 25 1 
BEGIN
 KEY "vettore, comune+provincia"
 PROMPT 9 20 ""
END

DATE 163 8 
BEGIN
 KEY "data inizio trasporto/consegna"
 PROMPT 38 18 ""
 FIELD DATAPART
 FORMAT "1442-"
 GROUP 5
 FLAGS "D"
END

STRING 164 5 
BEGIN
 KEY "ora inizio trasporto/consegna"
 PROMPT 47 18 ""
 PICTURE "##.##"
 FIELD ORAPART
 GROUP 5
 FLAGS "D"
END

DATE 165 8 
BEGIN
 KEY "data ritiro"
 PROMPT 38 18 ""
 FIELD DATAPART
 FORMAT "1442-"
 FLAGS "D"
 GROUP 6
END

STRING 166 5 
BEGIN
 KEY "ora ritiro"
 PROMPT 47 18 ""
 PICTURE "##.##"
 FIELD ORAPART
 FLAGS "D"
 GROUP 6
END

STRING 167 40 2
BEGIN
 KEY "note documento"
 PROMPT 2 22 ""
 FIELD 210@->S0
END

END

//   NOTE SULLA COMPILAZIONE DEI FORM DI STAMPA
//
//   SEZIONE GENERAL
//   ===============
//   Posizionamento:
//    e' possibile effettuari posizionamenti manuali dei form con le seguenti istruzioni:
//    CARATTERE <S> 
//    INIZIALE  <N> <N>
//    FINALE    <N> <N>
//   dove:
//      CARATTERE indica il carattere da stampare per contrassegnare il posizionamento, racchiuso tra doppi apici (eg "X")
//      INIZIALE  indica le coordinate X ed Y per il posizionamento iniziale (dove stampare il primo carattere)
//      FINALE    indica le coordinate X ed Y per il posizionamento finale (dove stampare il secondo carattere)
//   FINALE puo' essere omesso; se definito e' comunque buona norma tenere la coordinata verticale (Y) uguale
//   a quella indicata in INIZIALE, se diversi il programma tiene conto solo della prima.
//   Non e' possibile definire sia posizionamenti manuali che OFFSET, quindi o l'uno o l'altro, preferibilmente
//   e' meglio scegliere OFFSET.
//
//   Modificatori di pictures:
//   i parametri IMP_DECIMALS, QTA_DECIMALS, e PRI_DECIMALS settano i decimali da stampare/arrotondare
//   per i seguenti: importi in genere, quantita', e prezzi. Il primo parametro intero e' per gli importi in lire
//   il secondo per gli importi in valuta. Naturalmente per le quantita' non ha senso fare una cosa del genere, ma per completezza
//   e' stata implementata.
//   PRI_DECIMALS corrisponde al gruppo 29
//   QTA_DECIMALS corrisponde al gruppo 30
//   IMP_DECIMALS corrisponde al gruppo 31
//   pertanto tutti i campi che apparterranno al gruppo 29,30 o 31 avranno gli importi stampati al numero di decimali impostati a
//   seconda se il documento e' in lire o valuta. Se il numero di decimali e' 0 la picture rimarra' invariata.
//   Altri gruppi definiti dall'utente saranno cosi' sintatticamente impostati:
//   NEW_GROUP <n> <lit_dec> <val_dec>
//   Dove <n> e' il numero del gruppo
//        <lit_dec> e' il numero di decimali per i documenti in lire
//        <val_dec> e' il numero di decimali per i documenti in valuta
//   
//   Definizione di liste di esclusione (facoltativo):
//   EXCLUDE esclude dalla stampa le righe che soddisfano la condizione specificata.
//   Si indicano in questo modo: "<tipo riga>,<cod. art>". Naturalmente si possono indicare tutti gli EXLCUDE che si vogliono.
//   Es: EXCLUDE "V01,ART1" escludera' tutte le righe di tipo V01 con codice articolo ART1
//       EXCLUDE ",ART1" escludera' tutte le righe che hanno codice articolo ART1
//       EXCLUDE "V01," escludera' tutte le righe che hanno tipo riga V01
//       EXCLUDE "," non escludera' nulla.
//
//  MESSAGGI UTENTE
//  ===============
//  Note sui messaggi della testata/body/footer:
//
//  _ISAMREAD:
//    lettura generica di un file del database
//    sintassi: _ISAMREAD,<file>,<espressione input>[!<espressione input>!...],{<campo file>|<espressione output>[!<espressione output>!...]}
//    dove: <file>  il numero logico del file o il nome della tabella
//       <espressione input>  un'espressione del tipo <campo file>=<espressione campi form>
//       <espressione campi form>  un'espressione di costanti numeriche, stringhe e valori di campi della form (indicati con il loro numero preceduto da #)
//       <espressione output>  un'espressione del tipo <campo form o gruppo>=<campo file> (se  un gruppo deve essere seguito da @) oppure solo <campo file> (il campo della form  quello corrente)
//  
//  _TABLEREAD:
//    lettura generica di un campo di una tabella
//    sintassi: _TABLEREAD,<tabella>,<chiave>,<campo file>
//    dove: <tabella> nome tabella da leggere
//       <chiave> costante stringa o riferimento a campo della form (preceduto da '#') da usare come chiave di ricerca
//       <campo file> identificativo del campo da leggere dalla tabella
//
//  _DITTA:
//    lettura dei dati della ditta
//    sintassi: _DITTA,{<campo relazione>|<macro>}
//    dove: <campo relazione>  un riferimento alla relazione di gestione dei dati della ditta (es. 113@->DENCOM  la denominazione del comune di residenza della ditta)
//         <macro>  uno delle macro seguenti:
//         !RAGSOC  ragione sociale
//         !IND     indirizzo (fiscale se c', oppure di residenza)
//         !NUM     numero civico (fiscale se c', oppure di residenza)
//         !CAP     CAP (fiscale se c', oppure di residenza)
//         !COM     comune (fiscale se c', oppure di residenza)
//         !PROV    provincia (fiscale se c', oppure di residenza)
//         !IVA     partita iva
//         !CF      codice fiscale
//         !TEL     numero di telefono (con prefisso)
//         !FAX     numero di fax (con prefisso)
//         !REGSOC  numero di registrazione presso il Tribunale
//         !CCIAA   numero di registrazione presso la camera di commercio
//    nota: la relazione della ditta  cos strutturata:
//       %NDITTE (9) Dati ditte
//       + %ANAGR (6) Anagrafica generale (indirizzo, ecc.)
//          + %COMUNI (113@) Comune di residenza
//          + %COMUNI (213@) Comune di residenza fiscale
//    viene utilizzato perche' non e' possibile stabilire altrimenti una relazione con il file ditte
//    dall'interno del form.
//
//  _CLIENTE
//    lettura dei dati del cliente
//    sintassi: _CLIENTE,{<campo relazione>|<macro>}
//    dove: <campo relazione>  un riferimento alla relazione di gestione dei dati del cliente
//         <macro>  uno delle macro seguenti:
//         !RAGSOC  ragione sociale
//         !CAP     Codice Avviamento Postale (viene implementato un messaggio perche' sugli occasionali ha un nome campo diverso!!)
//         !IND     indirizzo
//         !NUM     numero civico
//         !INDNUM  indirizzo + numero civico
//         !INDSPED indirizzo spedizione + numero civico
//         !TEL     primo numero di telefono (con prefisso)
//         !TEL2    secondo numero di telefono (con prefisso)
//         !TEL3    terzo numero di telefono (con prefisso)
//         !FAX     numero di fax (con prefisso)
//         !COM-><FIELD>  accede ai campi del comune di residenza cliente
//         !COMN-><FIELD> accede ai campi del comune di nascita del cliente
//    nota: la relazione del cliente  cos strutturata:
//       CLIFO (20) Clienti/fornitori
//       + CFVEN (17) Clienti/fornitori per vendite
//       + %COMUNI (113@) Comune di residenza
//       + %COMUNI (213@) Comune di nascita
//    viene utilizzato al posto del file 17 collegato perche' vi sono particolari
//    accorgimenti per quanto riguarda i clienti occasionali.
// 
//  _DESCRIGA:
//    Messaggio per reperire e formattare anche la descrizione estesa sulle righe del documento
//
//  _ALIGN:
//    allineamento della posizione di un campo rispetto ad un altro
//    sintassi: _ALIGN,<campo form>[,<allineamento>][,<allineamento>...]
//    dove: <campo form>  il campo della form (preceduto da '#') da cui prendere l'allineamento
//       <allineamento>  uno dei seguenti valori:
//        TOP    allinea sulla riga d'inizio
//        MIDDLE allinea al centro (effettivo)
//        BOTTOM allinea sulla riga di fine (effettiva, non preimpostata)
//        LEFT   allinea sulla colonna d'inizio
//        RIGHT  allinea sulla colonna di fine
//
//  _PAGENO:
//    Messaggio per stampare il numero di pagina corrente
//
//  _RIEPILOGOIVA:
//    messaggio per stampare la tabella ripelogativa delle aliquote IVA e relative imposte
//    sintassi: _RIEPILOGOIVA,<selettore>,<macro>,<cambio codice>
//    dove: <selettore>  uno dei seguenti:
//        1 = codici IVA a regime normale
//        2 = codici IVA da ventilare
//        4 = codici IVA esenti
//        8 = codici IVA non imponibili
//       16 = codici IVA non soggetti
//       oppure la combinazione di uno o piu' di essi:
//       12 = 4+8, 19 = 1+2+16, 29 = 1+4+8+16 ecc...
//       pertanto per avere i non imponibili in totale il selettore sara' 1,
//       per avere gli esenti il selettore sara' 4; per avere i non soggetti + esenti
//       il selettore sara' 20  e cosi' via.
//    dove: <macro>  uno dei seguenti:
//        COD     colonna dei codici
//        IMP     colonna degli imponibili
//        IVA     colonna delle imposte
//        ALI     colonna delle aliquote
//        DES     colonna delle descrizioni (stampata solo se il regime IVA non e' normale)
//    dove: <cambio codice>  uno dei seguenti:
//        0        indica di non leggere il successivo codice IVA nella tabella riepilogativa
//        1        indica di leggere il successivo codice IVA nella tabella riepilogativa
//
//  _TOTIMPONIBILI:
//    messaggio per stampare diverse totalizzazioni di imponibili
//    sintassi: _TOTIMPONIBILI,<selettore>
//    dove: <selettore> funge da filtro per la somma degli imponibili
//    vedi _RIEPILOGOIVA per la spiegazione dei filtri selettivi
//
//  _SCADENZE:
//    messaggio per stampare le scadenze
//    sintassi: _SCADENZE,<macro>,<cambio codice>
//    dove <macro> e' uno dei seguenti:
//      DATA    : stampa la data di scadenza 
//      IMPORTO : stampa l'importo in scadenza
//    dove <cambio codice> vale 0 o 1 se indica di rendere corrente la prossima scadenza
//
//  CAMPI VIRTUALI
//  ==============
//  Oltre a stampare i campi normali del file e' anche possibile stampare i campi virtuali
//  definiti nei profili semplicemente indicandoli nella istruzione FIELD:
//  per la testata del documento:
//  BOLLI, BASESCONTO, IMPOSTE, PROVVD, SCONTOD, SPESEINC, TOTDOC, TOTMER, TOTNS, TOTPRE, TOTSPE
//  per le righe:
//  IMPLN, IMPLS, IMPNN, IMPNS, IMPOSTA, PREZZOLN, PREZZOLS, PREZZONN, PREZZONS, PROVVR, SCONTOR
//  oltre, naturalmente a quelli definiti dall'utente

