// Applicazione per la correzione dei punteggi
#include <libpq++.h>
#include "applicat.h"
#include "questionnaire.h"


class Score_Application : public Application
{
private:
  PgDatabase *_db1, *_db2, *_db3;
  Questionnaire _questionario;
  PgEnv      _environment;
  String _dbname;

protected:
  virtual bool create();
  virtual bool destroy();
  virtual void main_func();
  void correct();
public:
  Score_Application() {}
  virtual ~Score_Application() {};
};


bool Score_Application::create()
{  
  _dbname = POSTGRES_DB;
  _environment.Port(POSTGRES_PORT);
  _environment.Host(POSTGRES_HOST);

  return TRUE;
}

bool Score_Application::destroy()
{
  return TRUE;
}

void Score_Application::correct()
{
  String command, utente, modulo, testnum, user_answers, corrector_answers;
  double punteggio;
  int num=0, nv = 0;
  
  //command = "SELECT * FROM VERIFICHE";

  command = "SELECT * FROM CORRETTORI";
  /*command += modulo;
  command += " AND testnum='";
  command += testnum;
  command += "'";*/


  _db1->ExecCommandOk(command);
  const int tuples = _db1->Tuples();
  if (tuples > 0) {
    for (int i = 0; i<tuples; i++) // Ciclo su tutti i correttori
      {
	modulo = _db1->GetValue(i,"modulo");
	testnum = _db1->GetValue(i,"testnum");
	corrector_answers = _db1->GetValue(i,"risposte");
	
	command = "SELECT * FROM VERIFICHE WHERE modulo=";
	command += modulo;
	command += " AND TESTNUM='";
	command += testnum;
	command += "'";
	
	_db2->ExecCommandOk(command);
	const int tups = _db2->Tuples();
	if (tups > 0) {
	  for (int j=0;j<tups;j++) {
	    double score;
	    nv++;
	    utente = _db2->GetValue(j,"loginname");
	    punteggio = strtod(_db2->GetValue(j,"punteggio"),NULL);
	    user_answers = _db2->GetValue(j,"risposte");
	    _questionario.load(corrector_answers, user_answers);
	    score = strtod(dtoa(_questionario.calc_score()),NULL);
	    if (score != punteggio) {   
	      num++;
	      cout << "Punteggio non congruente:" << endl << "  Utente: " << utente << endl;
	      cout << "  Punteggio calcolato= " << dtoa(score) << endl;
	      cout << "  Punteggio mem.= " << dtoa(punteggio) << endl;
	      cout << "  Modulo: " << modulo << "  Livello : " << testnum << endl;
	      command = "UPDATE VERIFICHE SET punteggio=";
	      command += dtoa(_questionario.calc_score());
	      command += " WHERE loginname='";
	      command += utente;
	      command += "' AND MODULO=";
	      command += modulo;
	      command += " AND TESTNUM='";
	      command += testnum;
	      command += "'";
	      _db3->ExecCommandOk(command);
	    }
	  } 
	}
      }
    cout << endl << "Numero totale verifiche : " << nv << " di cui errate: " << num << endl;
  }
  else
    cout << "Nessuna verifica presente nel database" << endl;
}

void Score_Application::main_func()
{   
  _db1 = new PgDatabase(_environment, _dbname);
  _db2 = new PgDatabase(_environment, _dbname);
  _db3 = new PgDatabase(_environment, _dbname);
  if ( _db1->ConnectionBad() || _db2->ConnectionBad()|| _db3->ConnectionBad()) 
    cout << "Errore in connessione al database" << endl;
  else
    correct();
   
  delete _db1; // Termina la transazione
  delete _db2;
  delete _db3;

}

int main(int argc, char* argv[])
{
  Score_Application* a = new Score_Application();
 
  a->run(argc, argv);

  delete a;
  
  exit(0);
}



















