#=========================================================================
# Makefile for XI/CH source
# Orca Software distributes these makefiles for convenience.  Having a
# makefile for a particular platform does not imply that you have a
# license to use the source code on that platform.  Before using the
# source code on any given platform, make sure that you have purchased
# the appropriate license.
#

#=========================== System Defines ==============================
CC				= acc
XVTDIR			= $(HOME)/xvtdsc2/ch_sparc_sunos/ptk
XVTCHLIB		= $(XVTDIR)/lib/libxvtcui.a
CCOPTS                  = -DXI_USE_XVT -DXI_R4_API
CURLOPTS		=
XIDIR           = $(HOME)/xi

# --------------------------- Sun SPARC ------------------------------
CURLFLAGS		= -r furl -s
XVTFLAGS		=
LD_FLAGS		=
LIBS			= $(XVTLIBS) /usr/5lib/libcurses.a

#============================== Utilities ================================
CURL			= $(XVTDIR)/bin/curl $(CURLFLAGS)
INCLUDES		= -I$(XVTDIR)/include -I$(XIDIR)/include -I$(XIDIR)/src
CFLAGS			= $(CCOPTS) $(XVTFLAGS) $(INCLUDES)
XVTLIBS			= $(XVTCHLIB)

#============================== Resources ================================
.SUFFIXES: .url .frl

.url.frl:
  $(CURL) $(CURLOPTS) $(INCLUDES) $<

XILIB = ../lib/libxisch.a
SRC = $(XIDIR)/src
OBJP = $(XIDIR)/src/sch

$(XILIB): $(OBJP)/xiheap.o $(OBJP)/xitree.o $(OBJP)/xicf.o $(OBJP)/xitext.o $(OBJP)/xilm.o $(OBJP)/xilm2.o $(OBJP)/xilm3.o $(OBJP)/xistx.o $(OBJP)/xiutils.o $(OBJP)/xi.o $(OBJP)/xi2.o $(OBJP)/xidbg.o $(OBJP)/xierr.o $(OBJP)/xilmst.o $(OBJP)/xiport.o $(OBJP)/xibitmap.o
        ar rc $(XILIB) $(OBJP)/xiheap.o $(OBJP)/xitree.o $(OBJP)/xicf.o $(OBJP)/xitext.o $(OBJP)/xilm.o $(OBJP)/xilm2.o $(OBJP)/xilm3.o $(OBJP)/xistx.o $(OBJP)/xiutils.o $(OBJP)/xi.o $(OBJP)/xi2.o $(OBJP)/xidbg.o $(OBJP)/xierr.o $(OBJP)/xilmst.o $(OBJP)/xiport.o $(OBJP)/xibitmap.o 
  ranlib $(XILIB)

$(OBJP)/xiheap.o: $(SRC)/xiheap.c
  $(CC) -c $(CFLAGS) $(SRC)/xiheap.c -o $(OBJP)/xiheap.o

$(OBJP)/xitext.o: $(SRC)/xitext.c
  $(CC) -c $(CFLAGS) $(SRC)/xitext.c -o $(OBJP)/xitext.o

$(OBJP)/xilm.o: $(SRC)/xilm.c
  $(CC) -c $(CFLAGS) $(SRC)/xilm.c -o $(OBJP)/xilm.o

$(OBJP)/xilm2.o: $(SRC)/xilm2.c
  $(CC) -c $(CFLAGS) $(SRC)/xilm2.c -o  $(OBJP)/xilm2.o

$(OBJP)/xilm3.o: $(SRC)/xilm3.c
        $(CC) -c $(CFLAGS) $(SRC)/xilm3.c -o  $(OBJP)/xilm3.o

$(OBJP)/xistx.o: $(SRC)/xistx.c
  $(CC) -c $(CFLAGS) $(SRC)/xistx.c -o $(OBJP)/xistx.o

$(OBJP)/xiutils.o: $(SRC)/xiutils.c
  $(CC) -c $(CFLAGS) $(SRC)/xiutils.c -o $(OBJP)/xiutils.o

$(OBJP)/xi.o: $(SRC)/xi.c
  $(CC) -c $(CFLAGS) $(SRC)/xi.c -o $(OBJP)/xi.o

$(OBJP)/xi2.o: $(SRC)/xi2.c
  $(CC) -c $(CFLAGS) $(SRC)/xi2.c -o $(OBJP)/xi2.o

$(OBJP)/xitree.o: $(SRC)/xitree.c
  $(CC) -c $(CFLAGS) $(SRC)/xitree.c -o $(OBJP)/xitree.o

$(OBJP)/xicf.o: $(SRC)/xicf.c
  $(CC) -c $(CFLAGS) $(SRC)/xicf.c -o $(OBJP)/xicf.o

$(OBJP)/xidbg.o: $(SRC)/xidbg.c
  $(CC) -c $(CFLAGS) $(SRC)/xidbg.c -o $(OBJP)/xidbg.o

$(OBJP)/xierr.o: $(SRC)/xierr.c
        $(CC) -c $(CFLAGS) $(SRC)/xierr.c -o $(OBJP)/xierr.o

$(OBJP)/xilmst.o: $(SRC)/xilmst.c
        $(CC) -c $(CFLAGS) $(SRC)/xilmst.c -o $(OBJP)/xilmst.o

$(OBJP)/xiport.o: $(SRC)/xiport.c
        $(CC) -c $(CFLAGS) $(SRC)/xiport.c -o $(OBJP)/xiport.o

$(OBJP)/xibitmap.o: $(SRC)/xibitmap.c
        $(CC) -c $(CFLAGS) $(SRC)/xibitmap.c -o $(OBJP)/xibitmap.o

