/*******************************************************************************
*  Copyright 1991-1996 by ORCA Software, Inc.                                  *
*                                                                              *
*  All rights reserved.  May not be reproduced or distributed, in printed or   *
*  electronic form, without permission of ORCA Software, Inc.  May not be      *
*  distributed as object code, separately or linked with other object modules, *
*  without permission.                                                         *
*******************************************************************************/

#define XIWS_WIN   101
#define XIWS_XM    102
#define XIWS_MAC   103
#define XIWS_PM    104
#define XIWS_WM    105

#if !defined(XI_USE_XVT) && !defined(XI_USE_XM) && !defined(XI_USE_WIN)
#define XI_USE_XVT
#endif

#ifdef XI_USE_XVT
#include "xvt_env.h"

#ifndef XI_R4_API
#undef XIWS_WIN
#define XIWS_WIN WINWS
#undef XIWS_XM
#define XIWS_XM MTFWS
#undef XIWS_MAC
#define XIWS_MAC MACWS
#undef XIWS_PM
#define XIWS_PM PMWS
#undef XIWS_WM
#define XIWS_WM WMWS
#endif

#if XVTWS == MACWS
#define XIWS XIWS_MAC
#elif XVTWS == PMWS
#define XIWS XIWS_PM
#elif XVTWS == WIN32WS || XVTWS == WIN16WS
#define XIWS XIWS_WIN
#elif XVTWS == WMWS
#define XIWS XIWS_WM
#elif XVTWS == MTFWS || XVTWS == XOLWS
#define XIWS XIWS_XM
#endif

#endif

#ifdef XI_USE_XM
#define XIWS XIWS_XM
#define EOL_SEQ "\n"
#define SZ_FNAME 64
#endif

#ifdef XI_USE_WIN
#define XIWS XIWS_WIN
#define EOL_SEQ "\n"
#define SZ_FNAME 256
#endif

#define XI_CURSOR_RESIZE 8001
#define XI_CURSOR_HAND 8002
#define XI_CURSOR_VRESIZE 8003

#ifndef COMBO_ICON
#define COMBO_ICON 1026
#endif

#define NULL_MENU_RID 8000

#define XI_MENU_FILE          32000
#define XI_MENU_FILE_NEW      (XI_MENU_FILE+1)
#define XI_MENU_FILE_OPEN     (XI_MENU_FILE+2)
#define XI_MENU_FILE_CLOSE    (XI_MENU_FILE+3)
#define XI_MENU_FILE_SAVE     (XI_MENU_FILE+4)
#define XI_MENU_FILE_SAVE_AS  (XI_MENU_FILE+5)
#define XI_MENU_FILE_REVERT   (XI_MENU_FILE+6)
#define XI_MENU_FILE_PG_SETUP (XI_MENU_FILE+7)
#define XI_MENU_FILE_PRINT    (XI_MENU_FILE+8)
#define XI_MENU_FILE_QUIT     (XI_MENU_FILE+9)
#define XI_MENU_FILE_ABOUT    (XI_MENU_FILE+10)

#define XI_MENU_EDIT          32025
#define XI_MENU_EDIT_UNDO     (XI_MENU_EDIT+1)
#define XI_MENU_EDIT_CUT      (XI_MENU_EDIT+2)
#define XI_MENU_EDIT_COPY     (XI_MENU_EDIT+3)
#define XI_MENU_EDIT_PASTE    (XI_MENU_EDIT+4)
#define XI_MENU_EDIT_CLEAR    (XI_MENU_EDIT+5)

#define XI_MENU_FONT          32030
#define XI_MENU_FONT_SELECT   32031

#define XI_MENU_WIN           32100
#define XI_MENU_WIN_CASCADE   (XI_MENU_WIN+1)
#define XI_MENU_WIN_TILE_HORZ (XI_MENU_WIN+2)
#define XI_MENU_WIN_TILE_VERT (XI_MENU_WIN+3)
#define XI_MENU_WIN_CLOSE_ALL (XI_MENU_WIN+4)
